//==============================================================================
//
//           uĺE擾pGfBbgv
//
//==============================================================================
//                                 Copyright 2000-2001 Takeshi Okamoto(PAPY)
//                                 papy@hamal.freemail.ne.jp
//                                 http://homepage1.nifty.com/MADIA/ (Japanese)
//==============================================================================
//                                                                   Version 1.4
//==============================================================================
//
// Version 1.00     J@2000-09
//         1.1              2000-09-30
//         1.2              2000-10-19  Min.Max.PositionvpeB̃oOC
//         1.3              2000-11-18  OnChangeCxgǉ
//         1.4              2001-01-15  R|Ă̂C
//         1.5              2001-01-28  eLXgύXꂽlύX悤ɂB
//
//==============================================================================
unit EditUpDown;

interface

uses
  Windows, Classes, StdCtrls, ExtCtrls, Controls, Messages, SysUtils,
  Forms,CommCtrl;

type

{ TUpDownButton }

  TUpDownButton = class(TWinControl)
  private
    FMin: SmallInt;
    FMax: SmallInt;
    FPosition: SmallInt;
    function InitCommonControl(CC: Integer): Boolean;
    function GetPosition: SmallInt;
    procedure SetMin(Value: SmallInt);
    procedure SetMax(Value: SmallInt);
    procedure SetPosition (Value : SmallInt);
  protected
    procedure CreateParams(var Params: TCreateParams); override;
    procedure CreateWnd; override;
  public
    constructor Create(AOwner: TComponent); override;
    property Min      : SmallInt read FMin write SetMin;
    property MAX      : SmallInt read FMax write SetMax;
    property Position : SmallInt read GetPosition write SetPosition;
  published

  end;

{ TEditUpDown }
   TEditUpDown = class(TCustomEdit)
  private
    procedure SetMax (Value : SmallInt);
    procedure SetMin (Value : SmallInt);
    procedure SetPosition (Value : SmallInt);
    function  GetPosition  : SmallInt;
    procedure WMSIZE(var Msg: TWMSize); message WM_SIZE;
    procedure WMVSCROLL(var Msg : TWMVSCROLL); message WM_VSCROLL;
  protected
    procedure Loaded; override;
    procedure CreateParams(var Params: TCreateParams); override;
    procedure CreateWnd; override;
    procedure KeyPress(var Key: Char); override;
    procedure KeyDown(var Key: Word; Shift: TShiftState);override;
    procedure Change;override;
  public
    MyOwner       : TForm   ;
    MyOwnerHandle : integer ;
    FButton  : TUpDownButton;
    FMin     : SmallInt;
    FMax     : SmallInt;
    FPosition: SmallInt;
    function  GetMinHeight: Integer;
    procedure SetEditRect;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property Color;
    property Ctl3D;
    property DragCursor;
    property DragMode;
    property Enabled;
    property Font;
    property Max: SmallInt read FMax write SetMax;
    property Min: SmallInt read FMin write SetMin;
    property Position: SmallInt read GetPosition write SetPosition;
    property PopupMenu;
    property ReadOnly;
    property ShowHint;
    property Visible;
    property OnChange;
    property OnKeyPress;
    property OnKeyDown;
    property OnKeyUp;

  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('PAPY', [TEditUpDown]);
end;


////////////////////////////////////////////////////////////////////////////////


{ TEditUpDown }

///////////
constructor TEditUpDown.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FButton        := TUpDownButton.Create (Self);
  FButton.Width  := 15;
  FButton.Height := 17;
  FButton.Visible:= True;
  FButton.Parent := Self;
  Text := '0';
  FMax :=100;
end;

//////////
destructor TEditUpDown.Destroy;
begin
  FButton.Free ;
  inherited Destroy;
end;

/////////
procedure TEditUpDown.Loaded;
begin
  if Length(Inttostr(Fmax)) > Length(Inttostr(FMin))  then
   SendMessage(Self.Handle, EM_LIMITTEXT, Length(Inttostr(FMax)), 0)
 else
   SendMessage(Self.Handle, EM_LIMITTEXT, Length(Inttostr(FMin)), 0) ;
end;

/////////
procedure TEditUpDown.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  Params.Style := Params.Style or ES_MULTILINE or WS_CLIPCHILDREN or ES_RIGHT	;
end;

/////////
procedure TEditUpDown.CreateWnd;
begin
  inherited CreateWnd;
  SetEditRect;
end;

/////////
procedure TEditUpDown.SetEditRect;
var
  nSize: TRect;
begin
  SendMessage(Handle, EM_GETRECT, 0, LongInt(@nSize));
  nSize.Bottom := ClientHeight + 1;
  nSize.Right := ClientWidth - FButton.Width - 2;
  nSize.Top := 0;
  nSize.Left := 0;
  SendMessage(Handle, EM_SETRECTNP, 0, LongInt(@nSize));
  SendMessage(Handle, EM_GETRECT, 0, LongInt(@nSize));
end;

////////
function TEditUpDown.GetMinHeight: Integer;
var
  DC: HDC;
  SaveFont: HFont;
  i: Integer;
  SysMetrics, Metrics: TTextMetric;
begin
  DC := GetDC(0);
  GetTextMetrics(DC, SysMetrics);
  SaveFont := SelectObject(DC, Font.Handle);
  GetTextMetrics(DC, Metrics);
  SelectObject(DC, SaveFont);
  ReleaseDC(0, DC);
  i := SysMetrics.tmHeight;
  if i > Metrics.tmHeight then i := Metrics.tmHeight;
  Result := Metrics.tmHeight + i div 4 + GetSystemMetrics(SM_CYBORDER) * 4 + 2;
end;

/////////
procedure TEditUpDown.SetMax (Value : SmallInt);
begin
  FMax :=Value;
  FButton.Max :=Value;
  Self.Text :=Inttostr(FButton.Position);
  if Length(Inttostr(Value)) > Length(Inttostr(FMax))  then
     SendMessage(Self.Handle, EM_LIMITTEXT, Length(Inttostr(Value)), 0)
  else
     SendMessage(Self.Handle, EM_LIMITTEXT, Length(Inttostr(FMax)), 0)
end;

////////
procedure TEditUpDown.SetMin (Value : SmallInt);
begin
 FMin :=Value;
 FButton.Min :=Value;
 Self.Text :=Inttostr(FButton.Position);
 if Length(Inttostr(Value)) > Length(Inttostr(FMin))  then
   SendMessage(Self.Handle, EM_LIMITTEXT, Length(Inttostr(FMin)), 0)
 else
   SendMessage(Self.Handle, EM_LIMITTEXT, Length(Inttostr(Value)), 0)
end;

/////////
procedure TEditUpDown.SetPosition (Value : SmallInt);
begin
 FButton.Position:=Value;
 Self.Text :=Inttostr(FButton.Position);
 FPosition :=FButton.Position ;
end;

////////
function TEditUpDown.GetPosition: SmallInt;
begin
   Result :=FButton.Position;
end;

/////////
procedure TEditUpDown.WMVSCROLL(var Msg : TWMVSCROLL);
begin
  Fposition :=FButton.position;
  Text :=inttostr(FButton.position);
end;

/////////
procedure TEditUpDown.WMSize(var Msg: TWMSize);
var
  MinHeight: Integer;
begin
  inherited;
  MinHeight := GetMinHeight;

  if Height < MinHeight then
    Height := MinHeight
  else
  if FButton <> nil then
  begin

   if NewStyleControls and Ctl3D then
     FButton.SetBounds(Width - FButton.Width - 5, 0, FButton.Width, Height - 5)
   else
     FButton.SetBounds (Width - FButton.Width, 1, FButton.Width, Height - 3);

   SetEditRect;

  end;
end;

//////////
procedure TEditUpDown.Change;
Var
 buffer :integer;
begin
  inherited Change;
  Buffer :=StrToIntDef(Self.Text,FPosition);
  if (Buffer<=FMax) And (Buffer>=FMin) AND (BUffer<>FPosition)then
  begin
     FPosition :=Buffer;
     FButton.SetPosition(FPosition);
  end;
end;
/////////
procedure TEditUpDown.KeyPress(var Key: Char);
begin
 if not ((Key='0') or (Key='1') or (Key='2')  or (Key='3')  or (Key='4') or
   (Key='5') or (Key='6') or (Key='7')  or (Key='8')  or (Key='9')  or (Key='-')) then
 begin
   Key:= #0;
   MessageBeep(0);
 end;

 inherited KeyPress(Key);
end;

/////////
procedure TEditUpDown.KeyDown(var Key: Word; Shift: TShiftState);
Var
 Buffer :integer;
begin
  if Key=VK_UP then
  begin
   Buffer:=StrToIntDef(Self.text,Fposition);
   if (Buffer+1<=FMax) And (Buffer+1>=FMin) then
   SetPosition(BUffer+1);
  end;

  if Key=VK_DOWN then
  begin
   Buffer:=StrToIntDef(Self.text,Fposition);
   if (Buffer-1<=FMax) And (Buffer-1>=FMin) then
   SetPosition(BUffer-1);
  end;
  inherited KeyDown(Key,Shift);

end;





{ TUpDownButton }

///////////
constructor TUpDownButton.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Width  := GetSystemMetrics(SM_CXVSCROLL);
  Height := GetSystemMetrics(SM_CYVSCROLL);
  Height := Height + (Height div 2);
  FMax :=  100   ;
end;

/////////
procedure TUpDownButton.CreateParams(var Params: TCreateParams);
begin

  InitCommonControl(ICC_UPDOWN_CLASS);
  inherited CreateParams(Params);
  with Params do
  begin
    Style := Style or UDS_SETBUDDYINT;
    Style := Style or UDS_ALIGNRIGHT ;
    Style := Style or UDS_NOTHOUSANDS;
    Style := Style or UDS_ARROWKEYS;
  end;

  CreateSubClass(Params, UPDOWN_CLASS);

  with Params.WindowClass do
    style := style and not (CS_HREDRAW or CS_VREDRAW) or CS_DBLCLKS;

 end;

//////////
procedure TUpDownButton.CreateWnd;
var
  MyWidth: Integer;
  AccelArray: array [0..0] of TUDAccel;
begin
  MYWidth := Width;
  inherited CreateWnd;
  Width := MyWidth;

  SendMessage(Handle, UDM_SETRANGE, 0, MakeLong(FMax, FMin));
  SendMessage(Handle, UDM_SETPOS, 0, MakeLong(FPosition, 0));
  SendMessage(Handle, UDM_GETACCEL, 1, Longint(@AccelArray));
  SendMessage(Handle, UDM_SETACCEL, 1, Longint(@AccelArray));

end;

////////
function TUpDownButton.InitCommonControl(CC: Integer): Boolean;
var
  IBM: TInitCommonControlsEx;
begin
   IBM.dwSize := SizeOf(TInitCommonControlsEx);
   IBM.dwICC := CC;
   Result := InitCommonControlsEx(IBM);
   if not Result then InitCommonControls;
end;

/////////
procedure TUpDownButton.SetPosition (Value : SmallInt);
begin
 SendMessage(Handle, UDM_SETPOS, 0, MakeLong(Value, 0));
end;

/////////
procedure TUpDownButton.SetMin (Value : SmallInt);
begin
 if Value <> FMin then
  begin
    FMin := Value;
    if HandleAllocated then
      SendMessage(Handle, UDM_SETRANGE, 0, MakeLong(FMax, FMin));
  end;
end;

/////////
procedure TUpDownButton.SetMax(Value: SmallInt);
begin
  if Value <> FMax then
  begin
    FMax := Value;
    if HandleAllocated then
      SendMessage(Handle, UDM_SETRANGE, 0, MakeLong(FMax, FMin));
  end;
end;

////////
function TUpDownButton.GetPosition: SmallInt;
begin
  if HandleAllocated then
  begin
    Result := LoWord(SendMessage(Handle, UDM_GETPOS, 0, 0));
    FPosition := Result;
  end
  else Result := FPosition;
end;


end.
