//==============================================================================
//
//           uOf[V^Cgo[v
//
//==============================================================================
//                                 Copyright 2000 Takeshi Okamoto(PAPY)
//                                 papy@hamal.freemail.ne.jp
//                                 http://homepage1.nifty.com/MADIA/ (Japanese)
//==============================================================================
//                                                                   Version 1.2
//==============================================================================
//
// Version 1.00     J@2000-09-30
//         1.1              2000-11-12
//            EEChEő̎j[s\ɂȂĂ̂CB
//         1.2              2000-11-19
//            EBorderStylebsDialog̎ACR`悳oOCB
//            E݌vɃJ[\ȂoOCB
//==============================================================================

unit GradBar;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs
  ,ExtCtrls;

{TGradationBar}
type
  TGradationStyle=(clLeftRight,clTopBottom) ;
  TJustification =(clLeft,ClCenter,clRight);
  TGradationBar = class(TComponent)
  private
     FActive_StartColor       : TColor          ;
     FActive_EndColor         : TColor          ;
     FActive_Font             : TFont           ;
     FActive_Picture          : Tpicture        ;
     FActive_GradationStyle   : TGradationStyle ;
     FActive_Justification    : TJustification  ;
     FPassive_StartColor      : TColor          ;
     FPassive_EndColor        : TColor          ;
     FPassive_Font            : TFont           ;
     FPassive_Picture         : Tpicture        ;
     FPassive_GradationStyle  : TGradationStyle ;
     FPassive_Justification   : TJustification  ;

     ActiveWindow    : Boolean    ; //EChEANeBuH̃tO
     ALLButtonSize   : integer    ; //
     FCaption        : String     ; //
     MyOwner         : TForm      ; //R|uĂtH[
     FHookWndProc    : Pointer    ; //
     FAddress        : Pointer    ; //̃EChEvV[W
     CloseButtonRect : TRect      ; //{^̃TCY
     BarRect         : TRect      ; //^Cgo[̃TCY
     FMemoryBMP      : TImage     ; //
     Flag            : boolean    ; //
     MyOwnerHandle   : integer    ; //CEChEԂɔԑOɎ擾Ēu


     procedure  DrawBar(TempBmp : integer)     ;
     procedure  DrawMyIcon(TempBmp : integer)  ;
     procedure  DrawButton(TempBmp : integer)  ;
     procedure  DrawCaption(TempBmp : integer) ;
     procedure  DrawRefresh ;
     procedure  GetBarRect(Var BarSize : TRect);
     Function   WMNCLBUTTONDOWN(var Msg: TWMNCLBUTTONDOWN):Boolean;
     procedure  WMSETCURSOR(var Msg: TWMSetCursor);
     procedure  WMACTIVATE(var Msg: TWMACTIVATE);
     procedure  HookWndProc( var Msg:TMessage );

  protected
     procedure  Loaded; override;
     procedure  SetCaption(Value :String);
     procedure  SetActive_Justification  (Value: TJustification);
     procedure  SetActive_GradationStyle  (Value: TGradationStyle);
     procedure  SetActive_Font(Value: TFont);
     procedure  SetActive_StartColor(Value: TColor);
     procedure  SetActive_EndColor(Value: TColor);
     procedure  SetActive_Picture(Value: TPicture);

     procedure  SetPassive_Justification  (Value: TJustification);
     procedure  SetPassive_GradationStyle  (Value: TGradationStyle);
     procedure  SetPassive_Font(Value: TFont);
     procedure  SetPassive_StartColor(Value: TColor);
     procedure  SetPassive_EndColor(Value: TColor);
     procedure  SetPassive_Picture(Value: TPicture);
  public
     procedure   UpDateCaption ;
     constructor Create(AOwner: TComponent); override;
     destructor  Destroy; override;
  published
     property Caption                   : String           read FCaption                 Write SetCaption;
     property Active_StartColor         : TColor           read FActive_StartColor       write SetActive_StartColor ;
     property Active_EndColor           : TColor           read FActive_EndColor         write SetActive_EndColor   ;
     property Active_Font               : TFont            read FActive_Font             write SetActive_Font;
     property Active_Picture            : TPicture         read FActive_Picture          write SetActive_Picture;
     property Active_GradationStyle     : TGradationStyle  read FActive_GradationStyle   write SetActive_GradationStyle;
     property Active_Justification      : TJustification   read FActive_Justification    write SetActive_Justification;
     property Passive_StartColor        : TColor           read FPassive_StartColor      write SetPassive_StartColor;
     property Passive_EndColor          : TColor           read FPassive_EndColor        write SetPassive_EndColor;
     property Passive_Font              : TFont            read FPassive_Font            write SetPassive_Font;
     property Passive_Picture           : TPicture         read FPassive_Picture         write SetPassive_Picture;
     property Passive_GradationStyle    : TGradationStyle  read FPassive_GradationStyle  write SetPassive_GradationStyle;
     property passive_Justification     : TJustification   read Fpassive_Justification   write Setpassive_Justification;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('PAPY', [TGradationBar]);
end;

////////////////////////////////////////////////////////////////////////////////

{---------------}
{TGradationBar}
{---------------}

///////////
constructor TGradationBar.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  With AOwner as TForm do
  MyOwner := TForm(AOwner)  ;

  If MyOwner.BorderStyle in [bsNone] Then
  begin
     raise Exception.Create('EChEX^CbsNonȅꍇ́ÃR|[lg͎gpł܂B');
     Destroy;
  end;

       MyOwnerHandle := MyOwner.Handle;
       FCaption      := MyOwner.Caption  ;

       FActive_Font     := TFont.Create;
       FActive_Picture  := TPicture.Create;
       FPassive_Font    := TFont.Create;
       FPassive_Picture := TPicture.Create;

       FActive_Justification   := clLeft;
       FActive_StartColor      := clBlue;
       FActive_endColor        := clBlack;
       FActive_GradationStyle  := clLeftRight;
       FActive_Font.Color      := clWhite;

       FPassive_Justification  := clLeft;
       FPassive_GradationStyle := clLeftRight;
       FPassive_Font.Color     := clWhite;
       FPassive_StartColor     := clBlack;
       Fpassive_endColor       := clWhite;

       ActiveWindow            := True;

       GetBarRect(BarRect);
       FMemoryBMP         :=TImage.Create(Self);
       FMemoryBMP.Width   :=GetSystemMetrics(SM_CXSCREEN);
       FMemoryBMP.Height  :=BarRect.Bottom;
       FMemoryBMP.IncrementalDisplay :=True;


       FHookWndProc := MakeObjectInstance(HookWndProc );
       FAddress     := Pointer(SetWindowLong(MyOwner.Handle, GWL_WNDPROC, Longint( FHookWndProc )));
end;

//////////
destructor TGradationBar.Destroy;
begin

 if FAddress<>nil then
 begin
  SetWindowLong(MyOwnerHandle,GWL_WNDPROC,Longint(FAddress));
  FreeObjectInstance(FHookWndProc);

  SetWindowPos(MyOwnerHandle, 0, 0, 0, 0, 0,
                SWP_FRAMECHANGED or SWP_DRAWFRAME or
                SWP_NOZORDER or SWP_NOMOVE or SWP_NOSIZE or SWP_NOACTIVATE);

  FPassive_Font.Free;
  FPassive_picture .Free;
  FActive_Font.Free;
  FActive_picture .Free;
  FMemoryBMP :=nil;

  end;

 inherited Destroy;

end;

/////////
procedure TGradationBar.Loaded;
begin
 UpDateCaption;
end;

/////////
procedure TGradationBar.SetActive_StartColor(Value: TColor);
begin
  FActive_StartColor :=Value;
  DrawRefresh
end;

/////////
procedure TGradationBar.SetActive_EndColor(Value: TColor);
begin
  FActive_EndColor :=Value;
  DrawRefresh
end;

/////////
procedure TGradationBar.SetActive_Font(Value: TFont);
begin
  FActive_Font.Assign(Value);
  DrawRefresh
end;

/////////
procedure TGradationBar.SetActive_Picture(Value: TPicture);
begin
  FActive_Picture.Assign(Value);
  DrawRefresh ;
end;

/////////
procedure TGradationBar.SetActive_GradationStyle (Value: TGradationStyle);
begin
  FActive_GradationStyle :=Value;
  DrawRefresh
end;

/////////
procedure  TGradationBar.SetActive_Justification  (Value: TJustification);
begin
  FActive_Justification :=Value;
  DrawRefresh
end;

/////////
procedure TGradationBar.SetPassive_StartColor(Value: TColor);
begin
  FPassive_StartColor :=Value;
  DrawRefresh
end;

/////////
procedure TGradationBar.SetPassive_EndColor(Value: TColor);
begin
  FPassive_EndColor :=Value;
  DrawRefresh
end;

/////////
procedure TGradationBar.SetPassive_Font(Value: TFont);
begin
  FPassive_Font.Assign(Value);
  DrawRefresh
end;

/////////
procedure TGradationBar.SetPassive_Picture(Value: TPicture);
begin
  FPassive_Picture.Assign(Value);
  DrawRefresh
end;

/////////
procedure TGradationBar.SetPassive_GradationStyle (Value: TGradationStyle);
begin
 FPassive_GradationStyle :=Value;
 DrawRefresh
end;

/////////
procedure  TGradationBar.SetPassive_Justification  (Value: TJustification);
begin
 FPassive_Justification :=Value;
 DrawRefresh
end;

//////////
procedure TGradationBar.SetCaption(Value :String);
begin
 MyOwner.Caption :=Value;
 FCaption :=Value;
 DrawRefresh
end;

/////////{xTuNX𒆎~ĂxTuNXJn}
procedure TGradationBar.UpDateCaption ;
begin
  SetWindowLong(MyOwnerHandle,GWL_WNDPROC,Longint(FAddress));
  FreeObjectInstance(FHookWndProc);

  BarRect.Top    :=0;
  BarRect.Left   :=0;
  BarRect.Right  :=0;
  BarRect.Bottom :=0;

  FHookWndProc := MakeObjectInstance(HookWndProc );
  FAddress     :=Pointer(SetWindowLong(MyOwner.Handle, GWL_WNDPROC, Longint( FHookWndProc )));
end;


/////////////////////////////^Cg`i~j///////////////////////////

///////// {Of[V{B} //ƉǂΎsx̌オ}邱Ƃł傤
procedure TGradationBar.DrawBar(TempBmp : integer);

     type
       TRGBColor=record
         Red,Green,Blue :Byte;
     end;

     //RGBlԁE΁E̋Pxlo
     procedure GetRGBColor(Value :TColor ;var FRGBColor : TRGBColor);
     begin
       FRGBColor.Red    := GetRValue(Value);
       FRGBColor.Green  := GetGValue(Value);
       FRGBColor.Blue   := GetBValue(Value);

     end;
var
i:integer;
FStartColor,FEndColor  : TRGBColor;
nBrush,OldBrush  : integer;
R1,G1,B1,R2,G2,B2: Double;
begin

     //摜̏ꍇ
     if ActiveWindow then
     begin
          if FActive_Picture.Graphic <>nil  then
          begin
              StretchBlt(TempBmp, BarRect.Left, BarRect.Top, BarRect.Right - BarRect.Left,
                         BarRect.Bottom - BarRect.Top,
                          FActive_Picture.Bitmap.Canvas.Handle, 0, 0,
                              FActive_Picture.width, FActive_Picture.Height, SRCCOPY);
              Exit;
          end;
      end
      else
      begin
         if FPassive_Picture.Graphic<>nil  then
          begin
              StretchBlt(TempBmp, BarRect.Left, BarRect.Top, BarRect.Right - BarRect.Left,
                         BarRect.Bottom - BarRect.Top,
                          FPassive_Picture.Bitmap.Canvas.Handle, 0, 0,
                              FPassive_Picture.width, FPassive_Picture.Height, SRCCOPY);
              Exit;
          end;
      end;

      //Of[VœFw肵ꍇisx̌}j
      if ActiveWindow then
      begin
          if FActive_StartColor=FActive_ENdColor  then
          begin
               nBrush := CreateSolidBrush(Active_StartColor);
               FillRect(TempBmp,BarRect,nBrush  ) ;
               DeleteObject(nBrush);
               Exit;
          end;
      end
      else
      begin
          if FPassive_StartColor=FPassive_ENdColor  then
          begin
               nBrush := CreateSolidBrush(Passive_StartColor);
               FillRect(TempBmp,BarRect,nBrush  ) ;
               DeleteObject(nBrush);
               Exit;
          end;
      end;

      //F̋Pxl擾
      if ActiveWindow then
      begin
        GetRGBColor(Active_StartColor, FStartColor);
        GetRGBColor(Active_EndColor, FEndColor) ;
      end
      else
      begin
        GetRGBColor(Passive_StartColor, FStartColor);
        GetRGBColor(Passive_EndColor, FEndColor)
      end;

      //RGBvZ
      R1 :=((FStartColor.Red-FEndColor.Red)/255);
      G1 :=((FStartColor.Green-FEndColor.Green)/255);
      B1 :=((FStartColor.Blue-FENdColor.Blue)/255);
      R2 :=FStartColor.Red;
      G2 :=FStartColor.Green;
      B2 :=FStartColor.Blue;

      for i:=0 to 255 -1 do
      begin

             //uV̍쐬
              nBrush    := CreateSolidBrush(RGB(Trunc(R2),Trunc(G2),Trunc(B2)));
             //uV̑I
              OldBrush  := SelectObject(TempBmp, nBrush);

             //덷̈
             if i=0 or 1  then
               PatBlt(TempBmp,0,0,Trunc((i*(BarRect.Right / 255))+
                                          (BarRect.Right  / 255)),BarRect.Bottom,PATCOPY);

              //Of[V{
              if ActiveWindow then
              begin
                    if FActive_GradationStyle<>clTopBottom then

                      //cɃOf[V
                      PatBlt(TempBmp,Trunc(i*(BarRect.Right / 255)),0,Trunc(i*(BarRect.Right/ 255)+
                                          (BarRect.Right  / 255)),BarRect.Bottom,PATCOPY)
                    else

                      //ɃOf[V
                      PatBlt(TempBmp,0,Trunc(i*(BarRect.Bottom / 255)),BarRect.Right,
                                Trunc(i*(BarRect.Bottom / 255)+(BarRect.Bottom / 255)),PATCOPY);
              end
              else
              begin
                   if FPassive_GradationStyle<>clTopBottom then

                     //cɃOf[V
                     PatBlt(TempBmp,Trunc(i*(BarRect.Right / 255)),0,Trunc(i*(BarRect.Right/ 255)+
                                         (BarRect.Right  / 255)),BarRect.Bottom,PATCOPY)
                   else

                     //ɃOf[V
                     PatBlt(TempBmp,0,Trunc(i*(BarRect.Bottom / 255)),BarRect.Right,
                               Trunc(i*(BarRect.Bottom / 255)+(BarRect.Bottom / 255)),PATCOPY);
              end;

                 R2  :=R2  - R1  ;
                 G2  :=G2  - G1  ;
                 B2  :=B2  - B1  ;

                 SelectObject(TempBmp, OldBrush);
                 DeleteObject(nBrush);

      end;

end;

/////////////////////////////{^`///////////////////////////////////////

/////////
procedure  TGradationBar.DrawButton(TempBmp :integer );
Var
  ButtonRect  : TRECT    ;  //{^̃TCY
begin

    if biSystemMenu in  MyOwner.BorderIcons  then
    begin

        //{^̃TCY擾
        With ButtonRect do
        begin
            Top    := BarRect.Top + 2  ;
            Left   := BarRect.Right - GetSystemMetrics(SM_CXSIZE);
            Bottom := Top + GetSystemMetrics(SM_CYSIZE) - 4  ;
            Right  := Left + GetSystemMetrics(SM_CXSIZE) - 2 ;

            //c[o[^̃X^C
            if MyOwner.BorderStyle in [bsToolWindow, bsSizeToolWin] then
            begin
                Bottom  := Bottom - 4;
                Left    := Left   + 5;
            end;
        end;

        //{^`悷
        DrawFrameControl(TempBmp, ButtonRect, DFC_CAPTION, DFCS_CAPTIONCLOSE) ;

        CloseButtonRect :=ButtonRect;

    end;


    //W̃X^CH
    If MyOwner.BorderStyle in [bsSizeable,bsSingle] Then
    begin

           //[Eő剻Eŏ]{^SċĂ邩H(biHelp)
           if MyOwner.BorderIcons =[biSystemMenu,biMaximize,biMinimize] then
           begin

                    ButtonRect.Left  := ButtonRect.Left  - GetSystemMetrics(SM_CXSIZE);
                    ButtonRect.Right := ButtonRect.Right - GetSystemMetrics(SM_CYSIZE);

                    //ő剻{^`
                    if IsZoomed(MyOwner.Handle) Then
                       DrawFrameControl(TempBmp, ButtonRect, DFC_CAPTION, DFCS_CAPTIONRESTORE)
                    else
                       DrawFrameControl(TempBmp, ButtonRect, DFC_CAPTION, DFCS_CAPTIONMAX);

                    ButtonRect.Left  := ButtonRect.Left  - GetSystemMetrics(SM_CXSIZE) + 2  ;
                    ButtonRect.Right := ButtonRect.Right - GetSystemMetrics(SM_CYSIZE) + 2 ;

                    //ŏ{^`
                    DrawFrameControl(TempBmp, ButtonRect, DFC_CAPTION, DFCS_CAPTIONMIN) ;

           end;

           //[Eő剻]{^Ă邩H
           if MyOwner.BorderIcons =[biSystemMenu,biMaximize] then
           begin

                    ButtonRect.Left  := ButtonRect.Left  - GetSystemMetrics(SM_CXSIZE);
                    ButtonRect.Right := ButtonRect.Right - GetSystemMetrics(SM_CYSIZE);

                   //ő剻{^`
                    if IsZoomed(MyOwner.Handle) Then
                       DrawFrameControl(TempBmp, ButtonRect, DFC_CAPTION, DFCS_CAPTIONRESTORE)
                    else
                       DrawFrameControl(TempBmp, ButtonRect, DFC_CAPTION, DFCS_CAPTIONMAX);

                    ButtonRect.Left  := ButtonRect.Left - GetSystemMetrics(SM_CXSIZE) + 2  ;
                    ButtonRect.Right := ButtonRect.Right - GetSystemMetrics(SM_CYSIZE) + 2 ;

                    //[ŏ]{^`
                    DrawFrameControl(TempBmp, ButtonRect, DFC_CAPTION, DFCS_CAPTIONMIN Or DFCS_INACTIVE) ;

          end;

          //[Eŏ]{^Ă邩H
          if MyOwner.BorderIcons =[biSystemMenu,biMinimize] then
          begin

                    ButtonRect.Left  := ButtonRect.Left  - GetSystemMetrics(SM_CXSIZE);
                    ButtonRect.Right := ButtonRect.Right - GetSystemMetrics(SM_CYSIZE);

                    //ő剻{^`
                    DrawFrameControl(TempBmp, ButtonRect, DFC_CAPTION,DFCS_CAPTIONMAX or DFCS_INACTIVE);

                    ButtonRect.Left  := ButtonRect.Left - GetSystemMetrics(SM_CXSIZE) + 2  ;
                    ButtonRect.Right := ButtonRect.Right - GetSystemMetrics(SM_CYSIZE) + 2 ;

                    //[ŏ]{^`
                    DrawFrameControl(TempBmp, ButtonRect, DFC_CAPTION, DFCS_CAPTIONMIN) ;

          end;

    end;

    ALLButtonSize := BarRect.Right - BarRect.Left - ButtonRect.Left - 2

end;

/////////////////////////////ACR`/////////////////////////////////////

/////////
procedure TGradationBar. DrawMyIcon(TempBmp :integer)  ;
Var
hDrawIcon : integer;
begin

  //ACRȂX^C(bsDialogǉ@2000/11/19)
  if MyOwner.BorderStyle in [bsToolWindow, bsSizeToolWin,bsDialog] then Exit;


  if MyOwner.Icon.Handle=0 then
      hDrawIcon:=  CopyImage(Application.Icon.Handle,
                                  IMAGE_ICON, GetSystemMetrics(SM_CXSIZE)- 2,
                                   GetSystemMetrics(SM_CYSIZE) - 2,
                                    LR_COPYFROMRESOURCE)

  else
      hDrawIcon:=  CopyImage(MyOwner.Icon.Handle,
                                  IMAGE_ICON, GetSystemMetrics(SM_CXSIZE)- 2,
                                   GetSystemMetrics(SM_CYSIZE) - 2,
                                    LR_COPYFROMRESOURCE);

      DrawIconEx(TempBmp, BarRect.Left + 2,BarRect.Top + 1,
                 hDrawIcon, 0,0, 0, 0, DI_NORMAL) ;

     //Application.IconƁAƂłȂƂɂȂ(܂)
     if MyOwner.Icon.Handle<>0 then  DestroyIcon(hDrawIcon);


end;

/////////////////////////////LvV`/////////////////////////////////

/////////
procedure  TGradationBar.DrawCaption(TempBmp : integer) ;
var
 FontRect    :  TRect   ;
 OldFont     :  integer ;
begin

  With FontRect  do
  begin
        Top    := BarRect.Top    ;
        Left   := GetSystemMetrics(SM_CXSIZE) + 6  ;
        Bottom := BarRect.Bottom              ;
        Right  := BarRect.Right - ALLButtonSize - GetSystemMetrics(SM_CXSIZE) + BarRect.Left + 6;
  end;

     //ACRȂEChȄꍇ(bsDialogǉ@2000/11/19)
     If MyOwner.BorderStyle in [bsToolWindow, bsSizeToolWin,bsDialog] Then FontRect.Left :=BarRect.Left+1;


     SetBkMode(TempBmp, TRANSPARENT) ;


    //LvV̈ʒuݒ
    if ActiveWindow then
    begin
          SetTextColor(TempBmp,FActive_Font.Color);
          OldFont := SelectObject(TempBmp,FActive_Font.Handle) ;
          case Active_Justification of
               clLeft   : DrawText(TempBmp, Pchar(MyOwner.Caption), -1, FontRect ,
                                  DT_VCENTER Or DT_SINGLELINE Or DT_END_ELLIPSIS or  DT_LEFT);

               clCenter : DrawText(TempBmp, Pchar(MyOwner.Caption), -1, FontRect ,
                                  DT_VCENTER Or DT_SINGLELINE Or DT_END_ELLIPSIS or  DT_Center);

               clRight  : DrawText(TempBmp, Pchar(MyOwner.Caption), -1, FontRect ,
                                   DT_VCENTER Or DT_SINGLELINE Or DT_END_ELLIPSIS or  DT_Right);
          end;
    end
    else
    begin
          SetTextColor(TempBmp,FPassive_Font.Color);
          OldFont := SelectObject(TempBmp,FPassive_Font.Handle) ;
          case Passive_Justification of
               clLeft   : DrawText(TempBmp, Pchar(MyOwner.Caption), -1, FontRect ,
                                  DT_VCENTER Or DT_SINGLELINE Or DT_END_ELLIPSIS or  DT_LEFT);

               clCenter : DrawText(TempBmp, Pchar(MyOwner.Caption), -1, FontRect ,
                                  DT_VCENTER Or DT_SINGLELINE Or DT_END_ELLIPSIS or  DT_Center);

               clRight  : DrawText(TempBmp, Pchar(MyOwner.Caption), -1, FontRect ,
                                   DT_VCENTER Or DT_SINGLELINE Or DT_END_ELLIPSIS or  DT_Right);
          end;
     end;

     SelectObject(TempBmp,OldFont);

end;

/////////////////////////////^CgTCY擾///////////////////////////////

/////////
procedure TGradationBar.GetBarRect(Var BarSize : TRect);
begin
    //EChETCY擾
    GetWindowRect(MyOwner.Handle, BarSize) ;

    With BarSize do
    begin

         //d̃EChEꍇ
         if  MyOwner.BorderStyle in [bsDialog,bsSingle,bsToolWindow] Then
         begin
           Right  := Right - Left - GetSystemMetrics(SM_CXSIZEFRAME)+1  ;
           Left   := GetSystemMetrics(SM_CXSIZEFRAME)-1                 ;
           Top    := GetSystemMetrics(SM_CYSIZEFRAME)-1                 ;
         end
         //d̃EChȄꍇ
         else
         begin
           Right  := Right - Left - GetSystemMetrics(SM_CXSIZEFRAME);
           Left   := GetSystemMetrics(SM_CXSIZEFRAME)               ;
           Top    := GetSystemMetrics(SM_CYSIZEFRAME)               ;
         end;

         //c[EChȄꍇ
         if MyOwner.BorderStyle in [bsToolWindow,bsSizeToolWin] Then
           Bottom := Top+GetSystemMetrics(SM_CYSMCAPTION) -1

         //W̃EChȄꍇ
         else
           Bottom := Top+GetSystemMetrics(SM_CYCAPTION) -1 ;
   end;
end;

/////////////////////////////`///////////////////////////////////////////

//////////
procedure  TGradationBar.DrawRefresh ;
var
MDC        : integer;   //foCXReLXg̃nh
OldMDC     : integer;   //ȑÕIuWFNg
Myhdc      : integer;   //FormŜ̃foCXReLXg
B_HANDLE   : integer;   //rbg}bṽnh
TitleRect  : TRect  ;
begin

    Myhdc :=GetWindowDC(MyOwner.Handle)  ;


    if not (csDesigning in ComponentState) then
    begin

        if Flag then
        begin

           GetBarRect(TitleRect);
           //2̗̈rēȂO̊G`(sx̌)
           if EqualRect(BarRect,TitleRect) then
           begin
             BitBlt(Myhdc,BarRect.Left, BarRect.Top, BarRect.Right - BarRect.Left,
                BarRect.Bottom - BarRect.Top, FMemoryBMP.Canvas.Handle, 0, 0, SRCCOPY );
             Exit;
           end;

        end;

     end;

   //EChETCY擾
   GetBarRect(BarRect);

   //݊̂郁foCXReLXg̍쐬
   MDC := CreateCompatibleDC(Myhdc) ;

   //rbg}bv̍쐬
   B_HANDLE := CreateCompatibleBitmap(Myhdc ,BarRect.Right, BarRect.Bottom) ;

   //rbg}bv̑I
   OldMDC :=SelectObject(MDC, B_HANDLE);

    DrawBar(MDC);
    DrawButton(MDC);
    DrawMyIcon(MDC);
    DrawCaption(MDC);

    //^Cgo[ɕ`悷
    BitBlt(Myhdc ,BarRect.Left, BarRect.Top, BarRect.Right - BarRect.Left,
         BarRect.Bottom - BarRect.Top, MDC, BarRect.Left, BarRect.Top, SRCCOPY );

    //C[WɊi[
    BitBlt(FMemoryBMP.canvas.handle ,0, 0,BarRect.Right,
            BarRect.Bottom, MDC, BarRect.Left, BarRect.Top, SRCCOPY );


    SelectObject(MDC, OldMDC);
    DeleteDC(MDC)  ;
    DeleteObject(B_HANDLE) ;
    ReleaseDC(MyOwner.Handle, Myhdc);

    Flag :=True;

end;

////////////////////////////bZ[W//////////////////////////////////////

/////////{bZ[W肻ĉ}
procedure TGradationBar.HookWndProc( var Msg:TMessage );
begin


      Case Msg.Msg of
          WM_ENTERIDLE      : DrawRefresh ;
          WM_CAPTURECHANGED : DrawRefresh ;
          WM_NCPAINT        : DrawRefresh ;
          WM_SETICON        : DrawRefresh ;
          WM_PAINT          : DrawRefresh ;
          WM_SYSCOMMAND     : DrawRefresh ;
          WM_NCACTIVATE     : DrawRefresh ;
          WM_SIZE           : DrawRefresh ;
          WM_ACTIVATE       : begin
                               WMACTIVATE(TWMACTIVATE(Msg));
                               UpDateCaption;
                               DrawRefresh;
                              end ;

          WM_SETCURSOR      : begin
                               if not (csDesigning in ComponentState) then
                               begin
                                 DrawRefresh;
                                 WMSETCURSOR(TWMSetCursor(Msg));
                                 Exit;
                               end;
                              end ;

          WM_NCLBUTTONDOWN  : begin
                               DrawRefresh;
                               if Not WMNCLBUTTONDOWN(TWMNCLBUTTONDOWN(Msg)) then
                                Exit;
                              end;
      end;

      with Msg do
      begin
        Result := CallWindowProc(FAddress ,MyOwner.Handle,Msg,WParam,LParam );
      end;
end;

/////////{J[\`悳ꂻȂłŕ`悷ih~j}
procedure TGradationBar.WMSETCURSOR(var Msg: TWMSetCursor);
begin

  case Msg.HitTest of
    HTTOP,HTBOTTOM                        : SetCursor(LoadCursor(0, MakeIntResource(IDC_SIZENS)));
    HTLEFT,HTRIGHT                        : SetCursor(LoadCursor(0, MakeIntResource(IDC_SIZEWE)));
    HTTOPRIGHT,HTBOTTOMLEFT               : SetCursor(LoadCursor(0, MakeIntResource(IDC_SIZENESW)));
    HTTOPLEFT,HTBOTTOMRIGHT               : SetCursor(LoadCursor(0, MakeIntResource(IDC_SIZENWSE)));
    HTCLIENT,HTCAPTION,HTCLOSE,
    HTMINBUTTON,HTMAXBUTTON,HTSYSMENU     : SetCursor(LoadCursor(0,MakeIntResource(IDC_ARROW)));
  end;

end;

/////////{NCAg̈ō}EXNbN}
function TGradationBar.WMNCLBUTTONDOWN(var Msg: TWMNCLBUTTONDOWN):Boolean;
begin

  Result :=False;

 if IsZoomed(MyOwner.Handle)  then
 begin

      Case  Msg.HitTest of    //HTMENUǉ(2000/11/12)
       HTSYSMENU,HTREDUCE,HTZOOM,HTSIZE,HTMENU : Result :=True;
      end;

      //͂܂낵Ȃ@łB(^^;
      if Msg.XCursor >CloseButtonRect.Left then
      begin
        if Msg.YCursor>CloseButtonRect.Top then Result :=True;
      end;
 end
 else
   Result :=True;

end;

/////////{EChEANeBuEANeBuɂȂ}
procedure TGradationBar.WMACTIVATE(var Msg: TWMACTIVATE);
begin
   Case Msg.Active of
     WA_INACTIVE  :  ActiveWindow :=False;
     WA_ACTIVE,WA_CLICKACTIVE    :  ActiveWindow :=True;
   end;
end;


end.
