//==============================================================================
//
//                     uOf[VQ[Wv
//
//==============================================================================
//                                 Copyright 2000 Takeshi Okamoto(PAPY)
//                                 papy@hamal.freemail.ne.jp
//                                 http://homepage1.nifty.com/MADIA/ (Japanese)
//==============================================================================
//                                                                   Version 1.1
//==============================================================================
//
// Version 1.00     Ŋ@2000-10-04
//         1.1                2001-01-18
//                               EoOC&R[hœK
//                               ER|uOf[VvOXo[v
//                               EuOf[VQ[WvɕύX
//
//==============================================================================

unit GradGauge;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

{TGradationGauge}
type
  TGradStyle = (gsHorizontal,gsVertical);
  TGradationGauge = class(TGraphicControl)
  private
      FFont           : TFont          ;
      FMin            : Word           ;
      FMax            : Word           ;
      FPosition       : Word           ;
      FGradStyle      : TGradStyle     ;
      FShowPercent    : boolean        ;
      FColor_Top      : TColor         ;
      FColor_Last     : Tcolor         ;
      FBackColor      : TColor         ;
      procedure SetFont(Value: TFont);
      procedure SetMin(Value :Word );
      procedure SetMax(Value :Word );
      procedure SetPosition(Value :Word );
      procedure SetGradStyle(Value : TGradStyle );
      procedure SetShowPercent(Value : Boolean );
      procedure SetColor_Top(Value : TColor );
      procedure SetColor_Last(Value : TColor );
      procedure SetBackColor(Value : TColor );
  protected
     procedure Paint;override;
  public
     constructor Create(Aowner: TComponent); override;
     destructor  Destroy; override;
  published
     property Align;
     property Visible;
     property DragCursor;
     property DragMode;
     property Enabled;
     property PopupMenu;
     property ParentShowHint;
     property ParentFont;
     property ShowHint;
     property OnMouseMove;
     property OnMouseDown;
     property OnMouseUp;
     property Font        : TFont          read FFont        write SetFont;
     property Min         : Word           read FMin         write SetMin;
     property Max         : Word           read FMax         write SetMax;
     property Position    : Word           read FPosition    write SetPosition;
     property GradStyle   : TGradStyle     read FGradStyle   write SetGradStyle;
     property ShowPercent : Boolean        read FShowPercent write SetShowPercent;
     property Color_Top   : TColor         read FColor_Top   write SetColor_Top;
     property Color_Last  : TColor         read FColor_Last  write SetColor_Last;
     property BackColor   : TColor         read FBackColor   write SetBackColor;

  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('PAPY', [TGradationGauge]);
end;

////////////////////////////////////////////////////////////////////////////////


///////////
function MakeGradation(Width,Height,Color_Top:integer; Color_Last : TColor;Style :TGradStyle):integer;
     type
       TRGBColor=record
         Red,Green,Blue :Byte;
     end;

     //RGBlԁE΁E̋Pxlo
     procedure GetRGBColor(Value :TColor ;var FRGBColor : TRGBColor);
     begin
       FRGBColor.Red    := GetRValue(Value);
       FRGBColor.Green  := GetGValue(Value);
       FRGBColor.Blue   := GetBValue(Value);
     end;
Var
 i                    : integer;
 FTopColor,FlastColor : TRGBColor;
 R1,G1,B1,R2,G2,B2    : Double;
 BMP                  : TBitmap;
begin
      GetRGBColor(Color_Top,  FTopColor);
      GetRGBColor(Color_Last, FLastColor) ;

      R1 :=((FTopColor.Red-FLastColor.Red)/255);
      G1 :=((FTopColor.Green-FLastColor.Green)/255);
      B1 :=((FTopColor.Blue-FLastColor.Blue)/255);
      R2 :=FTopColor.Red;
      G2 :=FTopColor.Green;
      B2 :=FTopColor.Blue;

      BMP :=TBitmap.Create;
      BMP.Width  :=Width;
      BMP.Height :=Height;

      for i:=0 to 255-1 do
      begin
             BMP.Canvas.Brush.Color := (RGB(Trunc(R2),Trunc(G2),Trunc(B2)));

             Case Style of

                 //cɃOf[V
                 gsHorizontal:
                            PatBlt(BMP.canvas.handle,Trunc(i*(Width / 255)),0,Trunc(i*(Width/ 255)+
                                  (Width / 255)),Height,PATCOPY);
                 //cɃOf[V
                 gsVertical :
                             PatBlt(BMP.canvas.handle,0,Trunc(i*(Height / 255)),Width,
                                Trunc(i*(Height / 255)+(Height / 255)),PATCOPY);
              end;

                R2  :=R2  - R1  ;
                G2  :=G2  - G1  ;
                B2  :=B2  - B1  ;

      end;
      Result :=BMP.ReleaseHandle;
      BMP.Free;
end;

///////////
constructor TGradationGauge.create(AOwner : TComponent);
begin
  inherited Create(AOwner);
  FFont       := TFont.Create;
  FFont.Color := clWhite   ;
  FFont.Style := [fsBold]  ;
  FMin        := 0         ;
  FMax        := 100       ;
  FPosition   := 0         ;
  FBackColor  := clBtnFace ;
  FColor_Top  := clBlue    ;
  FColor_Last := clBlack   ;
  Width       := 200       ;
  Height      := 25        ;
  FShowPercent:= True      ;
end;

//////////
destructor TGradationGauge.Destroy;
begin
  FFont.Free;
  inherited Destroy;
end;

/////////
procedure TGradationGauge.SetFont(Value: TFont);
begin
  if Value= FFont then Exit;
  FFont.Assign(Value);
  Paint;
end;

/////////
procedure TGradationGauge.SetShowPercent(Value : Boolean );
begin
  if Value= FShowPercent then Exit;
  FShowPercent :=Value ;
  Paint;
end;

////////
procedure TGradationGauge.SetBackColor(Value : TColor );
begin
 if Value= FBackColor then Exit;
 FBackColor:=Value;
 Paint;
end;

/////////
procedure TGradationGauge.SetMin(Value :Word );
begin
 if VAlue= FMin then Exit;
 if Value<=FMax then
 begin
   if Value <= FPosition then
   begin
     FMin :=Value ;
     Paint;
   end
   else
     Exit;
 end;
end;

/////////
procedure TGradationGauge.SetMax(Value :Word );
begin
 if Value= FMax then Exit;
 if  (Value>=FMin) And (FPosition<=Value) then
 begin
    FMax :=Value ;
    Paint;
 end;
end;

/////////
procedure TGradationGauge.SetPosition(Value :Word );
begin
  if Value=FPosition then exit;
  if (FMax<Value) And (Value>FMin) then
     FPosition :=FMax
  else
  begin
     if Value<FMin then
        FPosition  :=FMin
     else
        FPosition  :=Value;
  end;
  Paint;
end;

/////////
procedure TGradationGauge.SetColor_Top(Value : TColor );
begin
  if Value=FColor_Top then Exit;
  FColor_Top :=Value;
  Paint;
end;

/////////
procedure TGradationGauge.SetColor_Last(Value : TColor );
begin
  if Value= FColor_Last then Exit;
  FColor_Last :=Value;
  Paint;
end;

//////////
procedure TGradationGauge.SetGradStyle(Value : TGradStyle );
begin
 if Value <> FGradStyle then
 begin
  FGradStyle :=Value;
  Paint;
 end;
end;

//////////
procedure TGradationGauge.Paint;
var
 FPos             : integer;
 MySize           : TRect  ;
 BMP,TempBMP      : TBitmap;
begin

   BMP :=TBitmap.Create;
   BMP.Handle := MakeGradation(Width,Height,FColor_Top,FColor_Last,FGradStyle);

   TempBMP :=TBitmap.Create;
   TempBMP.Width  :=Self.Width;
   TempBMP.Height :=Self.Height;

   TempBMP.Canvas.Brush.Color :=FBackColor;
   TempBMP.Canvas.FillRect(Rect(0,0,Width,Height));

   TempBMP.Canvas.Font.Assign(FFont);
   SetBkMode(TempBMP.Canvas.Handle, TRANSPARENT) ;
   SetTextColor(TempBMP.Canvas.Handle,FFont.Color);

   MySize :=Rect(0,0,Self.Width,Self.Height);
     case FGradStyle of
       gsHorizontal:
          begin
            FPos := MulDiv(FPosition, Self.Width, FMax);
            BitBlt(TempBMP.Canvas.Handle ,0, 0,FPos,Self.Height, BMP.canvas.handle, 0, 0, SRCCOPY );
            if FShowPercent then
            begin
               if Muldiv(FPos, 100, Self.Width)<>-1 then
                 DrawText(TempBMP.Canvas.Handle, PChar(Inttostr(Muldiv(FPos, 100, Self.Width))+ '%'), -1,
                         MySize, DT_VCENTER Or DT_SINGLELINE Or DT_Center)
               else
                 DrawText(TempBMP.Canvas.Handle,'0%', -1,
                         MySize, DT_VCENTER Or DT_SINGLELINE Or DT_Center)
            end;
          end;
       gsVertical:
          begin
            FPos := MulDiv(FPosition, Self.Height, FMax);
            BitBlt(TempBMP.Canvas.Handle ,0, Self.Height-FPos,Self.Width,FPos, BMP.canvas.handle, 0, Self.Height-FPos, SRCCOPY );
            if FShowPercent then
            begin
               if Muldiv(FPos, 100, Self.Height)<>-1 then
                   DrawText(TempBMP.Canvas.Handle, PChar(Inttostr(Muldiv(FPos, 100, Self.Height))+ '%'), -1,
                         MySize, DT_VCENTER Or DT_SINGLELINE Or DT_Center)
               else
                   DrawText(TempBMP.Canvas.Handle, '0%', -1,
                         MySize, DT_VCENTER Or DT_SINGLELINE Or DT_Center);

            end;
          end;

      end;

     Canvas.CopyRect(Rect(0,0,Width,Height),TempBMP.canvas,Rect(0,0,Width,Height));
     DrawEdge(Self.Canvas.Handle, MySize, BDR_SUNKENOUTER, BF_RECT );
     BMP.Free;
     TempBMP.Free;
end;



end.
