//==============================================================================
//
//           ugAvP[Vqgv
//
//==============================================================================
//                                 Copyright 2000 Takeshi Okamoto(PAPY)
//                                 papy@hamal.freemail.ne.jp
//                                 http://homepage1.nifty.com/MADIA/ (Japanese)
//==============================================================================
//                                                                   Version 1.2
//==============================================================================
//
// Version 1.00     J@2000-09-24
//         1.1           @ 2000-09-30
//         1.2              2000-11-19
//                          @@@@@EeEChEANeBu̎qg
//                                      \oOCB@
//==============================================================================

unit CustomHint;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  StdCtrls,ExtCtrls;

type
  TNewFontStyle =(Normal,Style_B,Style_I,Style_U,Style_BI,Style_BU,Style_IU,Style_ALL);
  TBackStyle    =(clRectangle,clRoundRect);
  TArrow_Style  =(clRight,clLeft,clCenter);
  TShowHintTime =(Second_1,Second_2,Second_3,Second_4,Second_5,
                  Second_6,Second_7,Second_8,Second_9,Second_10,AllWays) ;

{THintWindow}

  THintWindow=class(TWinControl)
  protected
      procedure CreateParams(var Params: TCreateParams); override;
  public
      constructor Create(AOwner: TComponent)  ; override;
  end;

{TCustomHint}

  TCustomHint = class(TComponent)
  private

       MyOwner            : TForm           ;  //R|uꂽEChE

       FBackColor         : TColor          ;
       FPicture           : TPicture        ;
       FLines             : TStrings        ;
       FHintWindow        : THintWindow     ;  //qg̓yɂȂEChE
       FTitleLabel        : TLabel          ;  //^Cgp̃x
       FCaptionLabel      : TLabel          ;  //p̃x
       FImage             : TImage          ;  //qg̉摜
       FTransparent       : Boolean         ;  //摜𓧖ɂ邩H
       FTitle_Style       : TNewFontStyle   ;
       FTitle             : String          ;
       FTitle_Color       : TColor          ;
       FLines_Color       : TColor          ;
       FLines_Style       : TNewFontStyle   ;
       FArrow             : Boolean         ;
       FWindowStyle       : TBackStyle      ;
       FArrow_Style       : TArrow_Style    ;
       FAssociate         : TControl        ;
       FTimer             : TTimer          ;
       FShowHintTime      : TShowHintTime   ;
       FShowHintTimer     : TTimer          ;
       FOnShowHint        : TNotifyEvent    ;
       FShowhint          : Boolean         ;


       procedure SetShowHintTime(Value: TShowHintTime);
       procedure Update(Sender: TObject)  ;
       procedure NotShow(Sender: TObject)  ;
       procedure SetTitle(Value : string);
       procedure SetTitle_Color(Value: TColor);
       procedure SetTitle_Style(Value: TNewFontStyle);
       procedure SetTransparent(Value: Boolean);
       procedure SetLines(Value: TStrings);
       procedure SetLines_Style(Value: TNewFontStyle);
       procedure SetPicture(Value: TPicture);
       procedure SetBackColor(Value: TColor);
       procedure SetLines_Color(Value: TColor);
       procedure SetArrow(Value: boolean);
       procedure SetWindowStyle(Value: TBackStyle);
       procedure SetArrow_Style(Value: TArrow_Style);
       procedure SetAssociate(Value: TControl);
       procedure DoHint(Sender: TObject);
       procedure SetShowHint(Value : Boolean);

  protected

  public
       constructor Create(AOwner : TComponent); override; 
       destructor  Destroy; override;
       procedure   Loaded; override;

  published
      
       property Picture          : TPicture        read FPicture       write SetPicture;
       property BackColor        : TColor          read FBackColor     write SetBackColor  ;
       property Transparent      : Boolean         read FTransparent   write SetTransparent;
       property Title_Color      : TColor          read FTitle_Color   write SetTitle_Color  ;
       property Title_Style      : TNewFontStyle   read FTitle_Style   write SetTitle_Style  ;
       property Title            : String          read FTitle         write SetTitle  ;
       property Lines_Style      : TNewFontStyle   read FLines_Style   write SetLines_Style  ;
       property Lines_Color      : TColor          read FLines_Color   write SetLines_Color  ;
       property Lines            : TStrings        read FLines         write SetLines ;
       property Arrow            : Boolean         read FArrow         write SetArrow ;
       property WindowStyle      : TBackStyle      read FWindowStyle   write SetWindowStyle ;
       property Arrow_Style      : TArrow_Style    read FArrow_Style   write SetArrow_Style ;
       property Associate        : TControl        read FAssociate     write SetAssociate;
       property ShowHintTime     : TShowHintTime   read FShowHintTime  write SetShowHintTime;
       property OnShowHint       : TNotifyEvent    read FOnShowHint    write FOnShowHint;
       property ShowHint         : Boolean         read FShowHint      write SetShowHint;
end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('PAPY', [TCustomHint]);
end;



////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////




{-----------}
{TCustomHint}
{-----------}

///////////
constructor TCustomHint.Create(AOwner: TComponent);
begin

  inherited Create(AOwner);

  with AOwner as TForm do
  MyOwner                 := TForm(AOwner)      ;

  FShowHint               := True               ;
  FTimer                  := TTimer.Create(Self);
  FTimer.Interval         := 1000               ;
  FShowHintTimer          := TTimer.Create(Self);
  FShowHintTimer.Enabled  := False              ;
  FShowHintTimer.Interval := 3000               ;
  FShowHintTime           := Second_3           ;
  FArrow_Style            := clLeft             ;
  FWindowStyle            := clRoundRect        ;
  FArrow                  := True               ;
  FTitle_Style            := Style_B            ;
  FLines                  := TStringList.Create ;
  FBackColor              := clInfoBk           ;
  FTitle_Color            := clBlack            ;
  Fpicture                := TPicture.Create    ;

  if not (csDesigning in ComponentState) then
  begin

     //CEChE
     FHintWindow := THintWindow.Create(Self)  ;
     FHintWindow.Top     := 150               ;
     FHintWindow.Left    := 150               ;
     FHintWindow.Visible := True              ;
     FHintWindow.Parent  := MyOwner           ;
     FHintWindow.Color   := clInfoBk          ;
     FHintWindow.Visible := False             ;

     //qg̉摜
     FImage              := TImage.Create (Self) ;
     FImage.Parent       := FHintWindow          ;
     FImage.Top          := 10                   ;
     FImage.Left         := 18                   ;
     FImage.Width        := 16                   ;
     FImage.height       := 16                   ;
     FImage.Visible      := True                 ;
     FImage.Stretch      := True                 ;
     FImage.ControlStyle :=[csNoStdEvents]       ; //sxׁ̌̈ACxgȂ


    //^Cgpx
     FTitleLabel              := TLabel.Create (Self)    ;
     FTitleLabel.Parent       := FHintWindow             ;
     FTitleLabel.Top          := 12                      ;
     FTitleLabel.Left         := 40                      ;
     FTitleLabel.Width        := 40                      ;
     FTitleLabel.height       := 12                      ;
     FTitleLabel.Visible      := True                    ;
     FTitleLabel.ControlStyle :=[csNoStdEvents]          ; //sxׁ̌̈ACxgȂ


    //px
     FCaptionLabel              := TLabel.Create (Self)  ;
     FCaptionLabel.Parent       := FHintWindow           ;
     FCaptionLabel.Top          := 32                    ;
     FCaptionLabel.Left         := 19                    ;
     FCaptionLabel.Width        := 30                    ;
     FCaptionLabel.height       := 12                    ;
     FCaptionLabel.Visible      := True                  ;
     FCaptionLabel.ControlStyle :=[csNoStdEvents]        ; //sxׁ̌̈ACxgȂ

   end

end;

//////////
destructor TCustomHint.Destroy;
begin

  FLines.Free         ;
  FPicture.Free       ;
  FTimer.Free         ;
  FShowHintTimer.Free ;

  FHintWindow   :=nil;
  FTitleLabel   :=nil;
  FImage        :=nil;
  FCaptionLabel :=nil;

  inherited Destroy;

end;

procedure TCustomHint.Loaded;
var
MyHintPoint   : array[0..2] of  TPOINT ;
MyHintRect    : TRECT                  ;
Rgn1,Rgn2     : integer                ;
begin

//

if not (csDesigning in ComponentState) then
begin

   //ȂqgnȂ
   if FLines.Text =''then
      if FTitle='' then   Exit;

   if FTitle<>'' then
     if FLines.Text =''then  exit;

   //摜Ȃꍇ͐\
   if FPicture.Graphic=nil then
   begin
     FCaptionLabel.Top    :=0;
     FCaptionLabel.Left   :=0;
   end;


       //^Cg̃X^Cݒ
       Case  FTitle_Style  of

           Normal    : FTitleLabel.Font.Style :=[];
           Style_B   : FTitleLabel.Font.Style :=[fsBold];
           Style_I   : FTitleLabel.Font.Style :=[fsItalic];
           Style_U   : FTitleLabel.Font.Style :=[fsUnderline];
           Style_BI  : FTitleLabel.Font.Style :=[fsBold]+[fsItalic];
           Style_BU  : FTitleLabel.Font.Style :=[fsBold]+[fsUnderline];
           Style_ALL : FTitleLabel.Font.Style :=[fsUnderline]+[fsBold]+[fsItalic] ;

       end;

       //p̃X^Cݒ
       Case  FLines_Style  of

           Normal    : FCaptionLabel.Font.Style :=[];
           Style_B   : FCaptionLabel.Font.Style :=[fsBold];
           Style_I   : FCaptionLabel.Font.Style :=[fsItalic];
           Style_U   : FCaptionLabel.Font.Style :=[fsUnderline];
           Style_BI  : FCaptionLabel.Font.Style :=[fsBold]+[fsItalic];
           Style_BU  : FCaptionLabel.Font.Style :=[fsBold]+[fsUnderline];
           Style_ALL : FCaptionLabel.Font.Style :=[fsUnderline]+[fsBold]+[fsItalic] ;

       end;

        FCaptionLabel.Caption  := FLines.Text;
        FTitleLabel.Caption    := FTitle;
        FCaptionLabel.AutoSize := True;
        FTitleLabel.AutoSize   := True;


  //摜ꍇ
  if FPicture.Graphic<>nil then
  begin

        //qgEChẺݒ
        if FCaptionLabel.Width+FCaptionLabel.Left > FTitleLabel.Width +FTitleLabel.Left then
           FHintWindow.Width   :=FCaptionLabel.Width+(FImage.Left*2)  //Imagêق1Ȃ̂łgB
        else
           FHintWindow.Width   :=FTitleLabel.Width+FTitleLabel.Left+FImage.Left;

         //qgEChȄcݒ
         if FWindowStyle=clRoundRect then
           FHintWindow.Height  :=FCaptionLabel.Height+(FCaptionLabel.Top*2)+(Myowner.Font.Height)
         else
           FHintWindow.Height  :=FCaptionLabel.Height+FCaptionLabel.Top + FImage.Top+Myowner.Font.Height;

  end
  else
  begin

     //qgEChEۂȂ
     if FWindowStyle<>clRoundRect then
     begin
         FHintWindow.Width   :=FCaptionLabel.Width  +FCaptionLabel.Left  ;
         FHintWindow.Height  :=FCaptionLabel.Height +MyOwner.Font.Height ;
     end
     else
     begin
        FCaptionLabel.Top    :=5;
        FCaptionLabel.Left   :=5;                                      //21̓EChEۂ̂
        FHintWindow.Height   :=FCaptionLabel.Height+(FCaptionLabel.Top *2)+21+MyOwner.Font.Height ;
        FHintWindow.Width    :=FCaptionLabel.Width+(FCaptionLabel.Left*2);
     end;

     FTitleLabel.Caption :='';

  end;
 
//

 //pۂlp`̂ɂ̂
 if FWindowStyle=clRoundRect then
 begin

          //o^̃[W쐬AEBhEɐݒ肷B
          GetClientRect(FHintWindow.Handle,MyHintRect);

          Rgn1 := CreateRectRgn(MyHintRect.Left, MyHintRect.Top, MyHintRect.Right, MyHintRect.Bottom) ;
          Rgn2 := CreateRectRgn(MyHintRect.Left, MyHintRect.Top, MyHintRect.Right, MyHintRect.Bottom) ;

          CombineRgn(Rgn1, Rgn1, Rgn2, RGN_XOR) ;
          DeleteObject(Rgn2) ;

          //p̊ۂEBhẼ[W쐬
          Rgn2 := CreateRoundRectRgn(MyHintRect.Left, MyHintRect.Top, MyHintRect.Right, MyHintRect.Bottom - 20, 15, 15);

          //[W̌
          CombineRgn(Rgn1, Rgn1, Rgn2, RGN_OR) ;

          DeleteObject(Rgn2) ;


             if FArrow then
             begin
                case FArrow_Style of

                  clLeft:
                     begin
                         //̖
                         MyHintPoint[0].x := 20                         ;
                         MyHintPoint[0].y := MyHintRect.Bottom - 21     ;
                         MyHintPoint[1].x := 20 * 2                     ;
                         MyHintPoint[1].y := MyHintRect.Bottom - 21     ;
                         MyHintPoint[2].x := 20                         ;
                         MyHintPoint[2].y := MyHintRect.Bottom          ;
                     end;

                  clRight:
                     begin
                         //E̖
                         MyHintPoint[0].x := FHintWindow.width-20       ;
                         MyHintPoint[0].y := MyHintRect.Bottom - 21     ;
                         MyHintPoint[1].x := FHintWindow.width-(20 * 2) ;
                         MyHintPoint[1].y := MyHintRect.Bottom - 21     ;
                         MyHintPoint[2].x := FHintWindow.width-20       ;
                         MyHintPoint[2].y := MyHintRect.Bottom          ;
                     end;

                 clCenter:
                     begin
                         //E̖
                         MyHintPoint[0].x := FHintWindow.width div 2     ;
                         MyHintPoint[0].y := MyHintRect.Bottom - 21      ;
                         MyHintPoint[1].x := FHintWindow.width div 2 -21 ;
                         MyHintPoint[1].y := MyHintRect.Bottom - 21      ;
                         MyHintPoint[2].x := FHintWindow.width div 2     ;
                         MyHintPoint[2].y := MyHintRect.Bottom           ;
                     end;



               end;
               
                   //󕔕̃[W쐬
                    Rgn2 := CreatePolygonRgn(MyHintPoint[0], 3, ALTERNATE) ;

             end;

                 //[W̌
                 CombineRgn(Rgn1, Rgn1, Rgn2, RGN_XOR)  ;

                 //쐬[WEBhEɐݒ
                 SetWindowRgn(FHintWindow.Handle, Rgn1, True);

                 DeleteObject(Rgn1) ;
                 DeleteObject(Rgn2) ;

  end;


 //


    //摜\t
    if  FPicture.Graphic<>nil then FImage.Picture :=FPicture;

    //obNJ[̐ݒ
    FHintWindow.Color :=FBackColor;

    //^Cgp̃J[ݒ
    FTitleLabel.Font.color :=FTitle_Color;

    //p̃J[ݒ
      FCaptionLabel.FonT.Color :=FLines_Color;

    //摜𓧖ɂ̂H
    if FTransparent then  FImage.Transparent :=True;

    //XN[o[\Ȃ悤ɂ
    Myowner.VertScrollBar.Visible :=False;
    Myowner.HorzScrollBar.Visible :=False;

    //^C}[n
    if  FAssociate <> nil then
    begin

        FAssociate.Hint         := ''     ;
        FTimer.OnTimer          := Update ;
        FShowHintTimer.OnTimer  := NotShow;



    end;

end;


end;

/////////
procedure TCustomHint.Update(Sender: TObject) ;
var
Poi      : TPoint;
CtrlRect : TRect;
lngY     : integer;
begin

if Myowner.Visible then
begin

 if FAssociate.Visible  then
 begin


    if MyOwner.Handle=GetActiveWindow then  //C@2000/11/19
    begin

        GetCursorPos(Poi);

        //XN[W擾
        GetWindowRect(MyOwner.handle,CtrlRect );


        //EChE^Cg̕vZŎZo
        lngY  :=  MyOwner.Height - MyOwner.ClientHeight ;


           if Poi.x-CtrlRect.Left > FAssociate.Left+5  then
           begin
             if Poi.x-CtrlRect.Left <(Associate.Width)  + FAssociate.Left   then
             begin
               if Poi.y-CtrlRect.Top-lngY>(FAssociate.top)  then
               begin
                  if Poi.y-CtrlRect.Top-lngY < (FAssociate.Height) +FAssociate.Top-5 then
                  begin


                       if not FHintWindow.Visible  then
                       begin

                        if not FShowHintTimer.Enabled then
                        begin

                                case  FWindowStyle of

                                 {pۂEChE̎}
                                  clRoundRect:
                                    begin

                                            if FArrow then
                                            begin

                                                  case FArrow_Style of

                                                   clCenter:
                                                      begin

                                                          {Cennter̎}
                                                           FHintWindow.Top      := Poi.y -FHintWindow.Height  ;
                                                           FHintWindow.Left     := POi.x - FHintWindow.width div 2;
                                                           FHintWindow.Visible  := True;
                                                      end;

                                                   clLeft:
                                                      begin

                                                         {Left̎}
                                                           FHintWindow.Top     := Poi.y -FHintWindow.Height  ;
                                                           FHintWindow.Left    := POi.x-21 ;
                                                           FHintWindow.Visible := True;

                                                      end;

                                                   clRight:
                                                      begin

                                                         {Right̎}
                                                           FHintWindow.Top     := Poi.y -FHintWindow.Height  ;
                                                           FHintWindow.Left    := POi.x-FHintWindow.Width+21 ;
                                                           FHintWindow.Visible := True;

                                                      end;

                                                 end;
                                               end
                                               else
                                               begin

                                                 {Ȃ̎ŊpۂEChE̎}
                                                 FHintWindow.Top     := Poi.y -FHintWindow.Height+21 ;
                                                 FHintWindow.Left    := POi.x -(FHintWindow.Width div 4) ;
                                                 FHintWindow.Visible := True;

                                               end;


                                      end;

                                   {lpEChE̎}
                                   clRectangle :
                                      begin

                                           FHintWindow.Top     := Poi.y -FHintWindow.Height  ;
                                           FHintWindow.Left    := POi.x -(FHintWindow.Width div 4);
                                           FHintWindow.Visible := True;
                                      end;

                                 end;{end Case}

                               DoHint(Self);
                               //^C}[I
                               if FShowHintTime<>AllWays then  FShowHintTimer.Enabled :=True;

                            end;

                       end;

                  end
                  else
                  begin
                   FHintWindow.Visible    :=False;
                   FShowHintTimer.Enabled :=False;
                  end;
               end
               else
               begin
                 FHintWindow.Visible    :=False;
                 FShowHintTimer.Enabled :=False;
               end;
             end
             else
             begin
                FHintWindow.Visible    :=False;
                FShowHintTimer.Enabled :=False;
             end;
           end
           else
           begin
             FHintWindow.Visible    :=False;
             FShowHintTimer.Enabled :=False;
           end;

   end;

 end;

end;


end;


/////////
procedure TCustomHint.NotShow(Sender: TObject)  ;
begin
FHintWindow.Visible :=False;
end;

/////////
procedure TCustomHint.SetShowHintTime(Value: TShowHintTime);
begin

 FShowHintTime :=Value;

 Case Value of
       Second_1  : FShowHintTimer.Interval :=1000 ;
       Second_2  : FShowHintTimer.Interval :=2000 ;
       Second_3  : FShowHintTimer.Interval :=3000 ;
       Second_4  : FShowHintTimer.Interval :=4000 ;
       Second_5  : FShowHintTimer.Interval :=5000 ;
       Second_6  : FShowHintTimer.Interval :=6000 ;
       Second_7  : FShowHintTimer.Interval :=7000 ;
       Second_8  : FShowHintTimer.Interval :=8000 ;
       Second_9  : FShowHintTimer.Interval :=9000 ;
       Second_10 : FShowHintTimer.Interval :=10000;
       AllWays   : FShowHintTimer.Interval :=0    ;
 end;

end;

/////////
procedure TCustomHint.SetShowHint(Value : Boolean);
begin
FShowHint              :=Value;
FShowHintTimer.Enabled :=Value;
FTimer.Enabled         :=Value;
end;

/////////
procedure TCustomHint.DoHint(Sender: TObject);
begin
  if Assigned(FOnShowHint) then FOnShowHint(Sender);
end;

/////////
procedure TCustomHint.SetPicture(Value: TPicture);
begin
  FPicture.Assign(Value);
end;

/////////
procedure TCustomHint.SetBackColor(Value: TColor);
begin
  FBackColor :=Value;
end;

/////////
procedure TCustomHint.SetTransparent(Value: Boolean);
begin
  FTransparent :=Value;
end;


/////////
procedure TCustomHint.SetTitle_Color(Value: TColor);
begin
  FTitle_Color :=Value;
end;

/////////
procedure TCustomHint.SetTitle(Value : string);
begin
  FTitle :=Value;
end;

/////////
procedure TCustomHint.SetTitle_Style(Value: TNewFontStyle);
begin
  FTitle_Style :=Value;
end;

/////////
procedure TCustomHint.SetLines_Color(Value: TColor);
begin
  FLines_Color :=Value;
end;

/////////
procedure TCustomHint.SetLines_Style(Value: TNewFontStyle);
begin
  FLines_Style :=Value;
end;

/////////
procedure TCustomHint.SetLines(Value: TStrings);
begin
  FLines.Assign(Value);
end;

/////////
procedure TCustomHint.SetArrow(Value: boolean);
begin
  if FWindowStyle=clRectangle then  FWindowStyle :=clRoundRect;
  FArrow :=Value;
end;

/////////
procedure TCustomHint.SetWindowStyle(Value: TBackStyle);
begin
  if Value=clRectangle then FArrow :=False;
  FWindowStyle :=Value;
end;

/////////
procedure TCustomHint.SetArrow_Style(Value: TArrow_Style);
begin
  FArrow_Style :=Value;
end;

/////////
procedure TCustomHint.SetAssociate(Value: TControl);
begin
FAssociate :=Value;
end;

{-----------}
{THintWindow}
{-----------}

///////////
constructor THintWindow.Create(AOwner: TComponent);
begin
  inherited ;
end;
/////////
procedure THintWindow.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  Params.Style := WS_POPUP or WS_DISABLED       ;

end;








end.
