//==============================================================================
//
//                 @@@@ uC[Wr[v
//
//==============================================================================
//                                 Copyright 2001 Takeshi Okamoto(PAPY)
//                                 papy@hamal.freemail.ne.jp
//                                 http://homepage1.nifty.com/MADIA/ (Japanese)
//==============================================================================
//                                                                   Version 1.0
//==============================================================================
//
// Version 1.00     Ŋ@2001-01-24
//
//==============================================================================

unit ImageView;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,ExtCtrls ;

type
    TImageViewer = class;
    TImageItems  = class;
    TItemClickEvent=procedure(Caption:String; ItemIndex:integer;Panel,Image:Boolean;Item: TImageItems) of object;
    TItemDblClickEvent=procedure(Caption:String; ItemIndex:integer;Panel,Image:Boolean;Item: TImageItems) of object;
    TItemMouseDownEvent=procedure (Caption:String; ItemIndex:integer;Panel,Image:Boolean;Item: TImageItems; Button: TMouseButton; Shift: TShiftState; X, Y:Integer) of object;
    TItemMouseMoveEvent=procedure (Caption:String; ItemIndex:integer;Panel,Image:Boolean;Item: TImageItems; Shift: TShiftState; X, Y:Integer) of object;
    TItemMouseUpEvent  =procedure (Caption:String; ItemIndex:integer;Panel,Image:Boolean;Item: TImageItems; Button: TMouseButton; Shift: TShiftState; X, Y:Integer) of object;
    TViewerStyle =(vsAuto,vsLeft,vsTop);
    //vOXo[\pR[obNvV[W
    //TCreateViewerCallBack = procedure (const Min,Max,Pos:Integer;const dwFlag :Boolean);

{TImageItems-------------------------------------------------------------------}

    TImageItems = class(TCollectionItem)
    private
      FCaption    : String;
      FImage      : TPicture;
      MainPanels  : TPanel;
      Labels      : TPanel;
      ChildPanels : Tpanel;
      VeiwImage   : TPaintBox;
      procedure  SetPicture(Value: TPicture);
      procedure  SetCaption(Const Value : String) ;
      function   GetOwnerClass: TImageViewer;
    protected
      function  GetDisplayName: string; override;
    public
      Constructor Create(Collection: TCollection); override;
      Destructor  Destroy; override;
      procedure   Assign(Value: TPersistent); override;
      property    OwnerClass: TImageViewer read GetOwnerClass;
    published
      property Caption: String    read FCaption write SetCaption    ;
      property Image  : TPicture   read FImage   write SetPicture ;
    end;

{TImageItem--------------------------------------------------------------------}

    TImageItem = class(TCollection)
    private
      FOwnerClass : TImageViewer;
      procedure SetItem(Index: Integer; Value: TImageItems);
      function  GetItem(Index: Integer): TImageItems;
    protected
      function  GetOwner: TPersistent; override;
    public
      constructor Create(AOwner: TImageViewer);
      function  Add: TImageItems;
      property OwnerClass: TImageViewer read FOwnerClass;
      procedure Delete(index:integer);
      property Item[Index: Integer]: TImageItems read GetItem write SetItem; default;
    published
      //Itempublishedɐ錾D5̃RpCɓ{̂publicɐ錾
      //property Item[Index: Integer]: TImageItems read GetItem write SetItem; default;
    end;

{TImageViewer-------------------------------------------------------------------}

  TImageViewer = class(TScrollBox)
  private
    FItems        : TImageItem;
    MyOwner       : TForm;
    FPanelWidth   : integer;
    FPanelHeight  : integer;
    FShowCaption  : Boolean;
    FHotTrack     : Boolean;
    FHotPanelColor: TColor ;
    FHotTextCOlor : TColor ;
    FPanelColor   : TColor ;
    FSelectItem   : integer;
    FItemClickEvent : TItemClickEvent;
    FItemDblClickEvent : TItemDblClickEvent;
    FViewerStyle       : TViewerStyle;
    FItemMouseDownEvent     : TItemMouseDownEvent;
    FItemMouseUpEvent       : TItemMouseUpEvent;
    FItemMouseMoveEvent     : TItemMouseMoveEvent;

    procedure SeTImageItem(Value: TImageItem);
    procedure SetShowcaption(Value :Boolean) ;
    procedure SetPanelWidth(Value :integer);
    procedure SetPanelHeight(Value :integer);
    procedure SetHotPanelColor(Value :TColor);
    procedure SetPanelColor(Value :TColor);
    procedure SetHotTextCOlor(Value :TColor);
    procedure AllColorRestore;
    procedure ChangeHotColor(index:integer);
    procedure OnObjectClick(Sender: TObject);
    procedure OnObjectDblClick(Sender: TObject);
    procedure OnHotTrack(Sender: TObject; Shift: TShiftState; X, Y: Integer) ;
    procedure OnItemMouseDownEx(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y:Integer) ;
    procedure OnItemMouseUpEx(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y:Integer) ;
    procedure OnPiantEx(Sender: TObject);
  protected
    procedure Loaded ;override;
  public
    constructor Create(AOwner: TComponent);Override;
    destructor  Destroy;override;
    procedure   UpData_ImageViewer{(CreateViewerCallBack:TCreateViewerCallBack)};
    property SelectItem    : integer   read FSelectItem;

  published
    property Items       : TImageItem  read FItems         write SeTImageItem;
    property PanelWidth  : integer     read FPanelWidth    write SetPanelWidth;
    property PanelHeight : integer     read FPanelHeight   write SetPanelHeight;
    property ShowCaption : Boolean     read FShowcaption   write SetShowcaption;
    property HotTextColor  : TColor    read FHotTextCOlor  write SetHotTextCOlor;
    property HotTrack      : Boolean   read FHotTrack      write FHotTrack;
    property HotPanelColor : TColor    read FHotPanelColor write SetHotPanelColor;
    property PanelColor    : TColor    read FPanelColor    write SetPanelColor;
    property ViewerStyle   : TViewerStyle    read FViewerStyle    write FViewerStyle;

    property OnItemClick     : TItemClickEvent     read FItemClickEvent     write FItemClickEvent;
    property OnItemDblClick  : TItemDblClickEvent  read FItemDblClickEvent  write FItemDblClickEvent;
    property OnItemMouseDown : TItemMouseDownEvent read FItemMouseDownEvent write FItemMouseDownEvent;
    property OnItemMouseMove : TItemMouseMoveEvent read FItemMouseMoveEvent write FItemMouseMoveEvent;
    property OnItemMouseUp   : TItemMouseUpEvent   read FItemMouseUpEvent   write FItemMouseUpEvent;
    property Caption; //hbLO̎Ɏgp̂Œǉ(D3ł͈ӖȂ)
    property DragCursor;
    property Align;
    property DragMode;
    property Enabled;
    property Color ;
    property Font;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;

  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('PAPY', [TImageViewer]);
end;

////////////////////////////////////////////////////////////////////////////////


//******************************************************************************
// TImageItems
//******************************************************************************


////////
constructor TImageItems.Create(Collection: TCollection);
begin
  inherited Create(Collection);
  FImage   := TPicture.Create;
  FCaption :='' ;
  MainPanels  :=nil ;
  Labels      :=nil;
  ChildPanels :=nil ;
  VeiwImage   :=nil;
end;

////////
destructor TImageItems.Destroy;
begin
  FImage.Free;
  if VeiwImage<>nil   then  VeiwImage.Free;
  if ChildPanels<>nil then  ChildPanels.Free;
  if Labels<>nil      then  Labels.Free;
  if MainPanels<>nil  then  MainPanels.Free;

  inherited Destroy;
end;

////////
procedure TImageItems.SetCaption(Const Value : String) ;
begin
 if Value<> FCaption then  FCaption:=Value;
end;

/////////
procedure TImageItems.SetPicture(Value: TPicture);
begin
  FImage.Assign(Value);
end;

/////////
procedure TImageItems.Assign(Value: TPersistent);
var
  MenuItemsEx: TImageItems;
begin
  if Value is TImageItems then
  begin
    MenuItemsEx  := TImageItems(Value);
    FImage.Assign(MenuItemsEx.Image);
    FCaption     := MenuItemsEX.Caption ;
  end
  else
   inherited Assign(Value)
end;

////////
function TImageItems.GetDisplayName: string;
begin
  Result := FCaption;
  if Result = '' then Result := inherited GetDisplayName;
end;

////////
function TImageItems.GetOwnerClass: TImageViewer;
begin
   if (Collection is TImageItem) And Assigned(Collection) then
     Result := TImageItem(Collection).OwnerClass
   else
     Result := nil;
end;


//******************************************************************************
// TImageItem
//******************************************************************************

////////
constructor TImageItem.Create(AOwner: TImageViewer);
begin
  inherited Create(TImageItems);
  FOwnerClass   := AOwner;
end;

////////
function TImageItem.GetItem(Index: Integer): TImageItems;
begin
  Result := TImageItems(inherited GetItem(Index));
end;

////////
procedure TImageItem.SetItem(Index: Integer; Value: TImageItems);
begin
  inherited SetItem(Index, Value);
end;

////////
function TImageItem.Add: TImageItems;
begin
  Result:= TImageItems(inherited Add);
end;

////////
procedure TImageItem.Delete(index:integer);
begin
 //Ô
 try
  if (index=-1) or (Count=0) then Exit;
  Item[index].Free;
  OwnerClass.UpData_ImageViewer{(nil)};
 except
 end;
end;

////////
function TImageItem.GetOwner;
begin
  Result:= FOwnerClass;
end;

//******************************************************************************
// TImageViewer
//******************************************************************************

///////////
constructor TImageViewer.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FItems  := TImageItem.Create(Self);
  Width   :=150;
  Height  :=150;
  with AOwner as TForm do
  MyOwner := TForm(AOwner);
  FPanelWidth    :=120;
  FPanelHeight   :=140;
  FShowcaption   :=True;
  FHotTrack      :=True;
  FPanelColor    :=clsilver;
  FHotPanelColor :=clBlack;
  FHotTextCOlor  :=clWhite;
  FSelectItem    :=-1;
  Color          :=clWhite;
  FViewerStyle   :=vsAuto;
end;

//////////
destructor TImageViewer.Destroy;
begin
  FItems.Free;
  inherited Destroy;
end;

/////////
procedure TImageViewer.SeTImageItem(Value: TImageItem);
begin
  FItems.Assign(Value);
end;

/////////
procedure TImageViewer.SetShowcaption(Value :Boolean);
begin
  if Value=FShowCaption  then Exit;
  FShowCaption :=Value;
end;

/////////
procedure TImageViewer.SetPanelWidth(Value :integer);
begin
  if (Value=FPanelWidth) or (Value<30)   then Exit;
  FPanelWidth :=Value;
end;

/////////
procedure TImageViewer.SetPanelHeight(Value :integer);
begin
  if (Value=FPanelHeight) or (Value<30)  then Exit;
  FPanelHeight :=Value;
end;

/////////
procedure TImageViewer.SetHotPanelColor(Value :TColor);
begin
  if Value=FHotPanelColor  then Exit;
  FHotPanelColor :=Value;
end;

/////////
procedure TImageViewer.SetPanelColor(Value :TColor);
begin
  if Value=FPanelColor  then Exit;
  FPanelColor :=Value;
end;

/////////
procedure TImageViewer.SetHotTextCOlor(Value :TColor);
begin
  if Value=FHotTextColor  then Exit;
  FHotTextCOlor :=Value;
end;

/////////
procedure TImageViewer.Loaded ;
begin
  if   not (csDesigning	in ComponentState)  then   UpData_ImageViewer{(nil)};
  inherited  Loaded;
end;

////////
procedure TImageViewer.AllColorRestore;
Var
 i,Count :integer;
begin
  Count:= Items.Count-1;
  for i:=0 to Count do
  begin
    Items[i].MainPanels.Color :=FPanelColor;
   // Items[i].ChildPanels.Color:=FPanelColor;
    if (Items[i].Labels<>nil) and ( FShowcaption) then
    begin
      Items[i].Labels.Color :=FPanelColor;
      Items[i].Labels.Font.Color :=Font.color;
    end;
  end;
end;

/////////
procedure TImageViewer.ChangeHotColor(index:integer);
begin
   Items[index].MainPanels.Color :=FHotPanelColor;
   if (Items[index].Labels<>nil) and (FShowcaption) then
   begin
    Items[index].Labels.Color :=FHotPanelColor;
    Items[index].Labels.Font.Color :=FHotTextColor;
   end;
   {*ύXȂǂH*}
   //Items[index].ChildPanels.Color :=FHotPanelColor;
end;

/////////
procedure TImageViewer.OnObjectClick(Sender: TObject);
var
 i,Count     : integer;
 Panel : TPanel;
 Image : TPaintBox;
begin
  Count:= Items.Count-1;
  for i:=0 to Count do
  begin
     if Sender is Tpanel then
     begin
       With Sender as TPanel do
       Panel :=TPanel(Sender);

       //epl̏ꍇ
       if (Items[i].MainPanels.Left = Panel.Left) And
          (Items[i].MainPanels.Top = Panel.Top)  And
          (Panel.Parent=Self) then
       begin
           AllColorRestore;
           ChangeHotColor(i);
           FSelectItem :=i;
           if Assigned(FItemClickEvent) then FItemClickEvent(Items[i].caption,i,True,false,Items[i]);
           Exit;
       end;

       //qpl(xp)̏ꍇ
       if(Items[i].Labels<>nil) and (FShowcaption)  then
       begin
          if (Panel.Parent=Items[i].MainPanels) then
          begin
              AllColorRestore;
              ChangeHotColor(i);
              FSelectItem :=i;
              if Assigned(FItemClickEvent) then FItemClickEvent(Items[i].caption,i,True,False,Items[i]);
              Exit;
          end;
       end;

     end;

     //C[W̏ꍇ
     if Sender is TPaintBox then
     begin
       With Sender as TPaintBox do
       Image :=TPaintBox(Sender);

       if (Image.Parent=Items[i].ChildPanels) then
       begin
         AllColorRestore;
         ChangeHotColor(i);
         FSelectItem :=i;
         if Assigned(FItemClickEvent) then FItemClickEvent(Items[i].caption,i,False,True,Items[i]);
         Exit;
       end;
     end;

  end;
end;

/////////
procedure TImageViewer.OnObjectDblClick(Sender: TObject);
var
 i,Count     : integer;
 Panel : TPanel;
 Image : TPaintBox;
begin
  Count:= Items.Count-1;
  for i:=0 to Count do
  begin
     if Sender is Tpanel then
     begin
       With Sender as TPanel do
       Panel :=TPanel(Sender);

       //epl̏ꍇ
       if (Items[i].MainPanels.Left = Panel.Left) And
          (Items[i].MainPanels.Top = Panel.Top)  And
          (Panel.Parent=Self) then
       begin
           AllColorRestore;
           ChangeHotColor(i);
           FSelectItem :=i;
           if Assigned(FItemDblClickEvent) then FItemDblClickEvent(Items[i].caption,i,True,False,Items[i]);
           Exit;
       end;

       //qpl(xp)̏ꍇ
       if (Items[i].Labels<>nil) and (FShowcaption)  then
       begin
          if (Panel.Parent=Items[i].MainPanels) then
          begin
              AllColorRestore;
              ChangeHotColor(i);
              FSelectItem :=i;
              if Assigned(FItemDblClickEvent) then FItemDblClickEvent(Items[i].caption,i,True,False,Items[i]);
              Exit;
          end;
       end;

     end;

     //C[W̏ꍇ
     if Sender is TPaintBox then
     begin
       With Sender as TPaintBox do
       Image :=TPaintBox(Sender);

       if (Image.Parent=Items[i].ChildPanels) then
       begin
         AllColorRestore;
         ChangeHotColor(i);
         FSelectItem :=i;
         if Assigned(FItemDblClickEvent) then FItemDblClickEvent(Items[i].caption,i,False,True,Items[i]);
         Exit;
       end;
     end;

  end;

end;

/////////
procedure TImageViewer.OnHotTrack(Sender: TObject; Shift: TShiftState; X, Y: Integer) ;
var
 i,Count     : integer;
 Panel : TPanel;
 Image : TPaintBox;
begin
  Count:= Items.Count-1;
  for i:=0 to Count do
  begin
     if Sender is Tpanel then
     begin
       With Sender as TPanel do
       Panel :=TPanel(Sender);

       //epl̏ꍇ
       if (Items[i].MainPanels.Left = Panel.Left) And
          (Items[i].MainPanels.Top = Panel.Top)  And
          (Panel.Parent=Self) then
       begin
         if FHotTrack then
         begin
           AllColorRestore;
           ChangeHotColor(i);
           FSelectItem :=i;
         end;
         if Assigned(FItemMouseMoveEvent) then FItemMouseMoveEvent
            (Items[i].caption,i,True,False,Items[i],Shift,X,Y);
         Exit;
       end;

       //qpl(xp)̏ꍇ
       if (Items[i].Labels<>nil) and (FShowcaption)  then
       begin
          if (Panel.Parent=Items[i].MainPanels) then
          begin
            if FHotTrack then
            begin
              AllColorRestore;
              ChangeHotColor(i);
              FSelectItem :=i;
            end;
            if Assigned(FItemMouseMoveEvent) then FItemMouseMoveEvent
            (Items[i].caption,i,True,False,Items[i],Shift,X,Y);
            Exit;
          end;
       end;
     end;

     //C[W̏ꍇ
     if Sender is TPaintBox then
     begin
       With Sender as TPaintBox do
       Image :=TPaintBox(Sender);
       if (Image.Parent=Items[i].ChildPanels) then
       begin
          if FHotTrack then
          begin
             AllColorRestore;
             ChangeHotColor(i);
             FSelectItem :=i;
          end;
          if Assigned(FItemMouseMoveEvent) then FItemMouseMoveEvent
          (Items[i].caption,i,False,True,Items[i],Shift,X,Y);
          Exit;
       end;
     end;

  end;
end;

/////////
procedure TImageViewer.OnItemMouseDownEX(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y:Integer) ;
var
 i,Count     : integer;
 Panel : TPanel;
 Image : TPaintBox;
begin
  Count:= Items.Count-1;
  for i:=0 to Count do
  begin
     if Sender is Tpanel then
     begin
       With Sender as TPanel do
       Panel :=TPanel(Sender);

       //epl̏ꍇ
       if (Items[i].MainPanels.Left = Panel.Left) And
          (Items[i].MainPanels.Top = Panel.Top)  And
          (Panel.Parent=Self) then
       begin
           AllColorRestore;
           ChangeHotColor(i);
           FSelectItem :=i;
           if Assigned(FItemMouseDownEvent) then FItemMouseDownEvent
           (Items[i].caption,i,True,false,Items[i],Button,Shift,X,Y);
           Exit;
       end;

       //qpl(xp)̏ꍇ
       if (Items[i].Labels<>nil) and (FShowcaption)  then
       begin
          if (Panel.Parent=Items[i].MainPanels) then
          begin
              AllColorRestore;
              ChangeHotColor(i);
              FSelectItem :=i;
              if Assigned(FItemMouseDownEvent) then FItemMouseDownEvent
              (Items[i].caption,i,True,false,Items[i],Button,Shift,X,Y);
              Exit;
          end;
       end;

     end;

     //C[W̏ꍇ
     if Sender is TPaintBox then
     begin
       With Sender as TPaintBox do
       Image :=TPaintBox(Sender);

       if (Image.Parent=Items[i].ChildPanels) then
       begin
         AllColorRestore;
         ChangeHotColor(i);
         FSelectItem :=i;
         if Assigned(FItemMouseDownEvent) then FItemMouseDownEvent
         (Items[i].caption,i,False,True,Items[i],Button,Shift,X,Y);
         Exit;
       end;
     end;

  end;
end;

/////////
procedure TImageViewer.OnItemMouseUpEx(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y:Integer) ;
var
 i,Count     : integer;
 Panel : TPanel;
 Image : TPaintBox;
begin
  Count:= Items.Count-1;
  for i:=0 to Count do
  begin
     if Sender is Tpanel then
     begin
       With Sender as TPanel do
       Panel :=TPanel(Sender);

       //epl̏ꍇ
       if (Items[i].MainPanels.Left = Panel.Left) And
          (Items[i].MainPanels.Top = Panel.Top)  And
          (Panel.Parent=Self) then
       begin
           if Assigned(FItemMouseUpEvent) then FItemMouseUpEvent
           (Items[i].caption,i,True,false,Items[i],Button,Shift,X,Y);
           Exit;
       end;

       //qpl(xp)̏ꍇ
       if (Items[i].Labels<>nil) and (FShowcaption)  then
       begin
          if (Panel.Parent=Items[i].MainPanels) then
          begin
              if Assigned(FItemMouseUpEvent) then FItemMouseUpEvent
              (Items[i].caption,i,True,false,Items[i],Button,Shift,X,Y);
              Exit;
          end;
       end;

     end;

     //C[W̏ꍇ
     if Sender is TPaintBox then
     begin
       With Sender as TPaintBox do
       Image :=TPaintBox(Sender);

       if (Image.Parent=Items[i].ChildPanels) then
       begin
         if Assigned(FItemMouseUpEvent) then FItemMouseUpEvent
         (Items[i].caption,i,False,True,Items[i],Button,Shift,X,Y);
         Exit;
       end;
     end;

  end;

end;

/////////
procedure TImageViewer.OnPiantEx(Sender: TObject);
Var
 _Width,_Heihgt:integer;
begin
  //yCg

  _Width:=Items[(sender as TPaintBox).tag].FImage.Bitmap.Width;
  _Heihgt:=Items[(sender as TPaintBox).tag].FImage.Bitmap.Height;

  //[hC[W̃TCYC[WRg[菬ꍇiZ^O@̋)
  if (_Width<90) or(_Heihgt<90)  then
  begin
     (Sender as TPaintBox).canvas.
     Draw((90-_Width) div 2 ,(90-_Heihgt) div 2 ,Items[(sender as TPaintBox).tag].FImage.Bitmap) ;
  end
  else
  begin
    (Sender as TPaintBox).canvas.
     StretchDraw(Rect(0,0,90,90),Items[(sender as TPaintBox).tag].FImage.Bitmap) ;
  end;
end;

////////
procedure  TImageViewer.UpData_ImageViewer{(CreateViewerCallBack:TCreateViewerCallBack)};
Var
 i,ImageCount,HeightCount,WidthCount ,y ,Count:integer;
begin
  Count:=Items.Count-1;
  //R͂킩Ȃɍ폜ĂȂƂ܂Ȃ
  for i:=0 to Count do
  begin
      if Items[i].VeiwImage<>nil then Items[i].VeiwImage.Free;
      if Items[i].ChildPanels<>nil then Items[i].ChildPanels.Free;
      if Items[i].Labels<>nil then Items[i].Labels.Free;
      if Items[i].MainPanels<>nil then Items[i].MainPanels.Free;
  end;

  y:=2;
  ImageCount :=0;
  HeightCount :=1;
  WidthCount := Trunc(Self.Width/PanelWidth);

  if FViewerStyle= vsAuto then if (width<PanelWidth) or (Height<PanelHeight) then  FViewerStyle :=vsTop;

               Count:=Items.Count-1;

               for i:=0 to Count do
               begin

                           //Cpl쐬
                           Items[i].MainPanels :=TPanel.Create(MyOwner);
                           Items[i].MainPanels.Parent := self;
                           Items[i].MainPanels.Width  := PanelWidth;
                           Items[i].MainPanels.Height := PanelHeight;

                          Case FViewerStyle of
                              vsLeft : begin
                                         Items[i].MainPanels.Top    := 0;
                                         Items[i].MainPanels.Left   := i*PanelWidth;
                                       end;
                              vsTop  : begin
                                         Items[i].MainPanels.Top    := i*PanelHeight;
                                         Items[i].MainPanels.Left   := 0;
                                       end;
                              vsAuto : begin
                                           if i < WidthCount then
                                           begin
                                             Items[i].MainPanels.Top    :=0;
                                             Items[i].MainPanels.Left   := i*PanelWidth;
                                           end
                                           else
                                           begin
                                             if i>=WidthCount*Y then
                                             begin
                                               inc(HeightCount);
                                               ImageCount :=0;
                                               inc(Y);
                                             end;

                                             Items[i].MainPanels.Top    :=HeightCount*PanelHeight;
                                             Items[i].MainPanels.Left   :=ImageCount*PanelWidth;
                                             inc(ImageCount);
                                           end;
                                        end;
                           end;

                           Items[i].MainPanels.BevelInner :=bvRaised;
                           Items[i].MainPanels.BevelOuter :=bvRaised;
                           Items[i].MainPanels.OnClick     :=OnObjectClick;
                           Items[i].MainPanels.OnDblClick  :=OnObjectDblClick;
                           Items[i].MainPanels.OnMouseMove := OnHotTrack ;
                           Items[i].MainPanels.Color       := FPanelColor;
                           Items[i].MainPanels.OnMouseDown :=OnItemMouseDownEx;
                           Items[i].MainPanels.OnMouseUp :=OnItemMouseUpEX;


                           //Cpl̏Ƀxp̃pl쐬
                              Items[i].Labels           := TPanel.Create(MyOwner);
                              Items[i].Labels.Parent    := Items[i].MainPanels;
                              Items[i].Labels.Caption   := Items[i].FCaption;
                              Items[i].Labels.Alignment := taCenter;
                              Items[i].Labels.Font.size := 8;
                              Items[i].Labels.Align     := alBottom;
                              Items[i].Labels.BevelInner:= bvnone;
                              Items[i].Labels.BevelOuter:= bvnone;
                              Items[i].Labels.Height    := 20;
                              Items[i].Labels.OnClick   := OnObjectClick;
                              Items[i].Labels.OnDblClick  :=OnObjectDblClick;
                              Items[i].Labels.OnMouseMove :=  OnHotTrack ;
                              Items[i].Labels.OnMouseDown :=OnItemMouseDownEX;
                              Items[i].Labels.OnMouseUp :=OnItemMouseUpEX;
                              Items[i].Labels.COlor :=FPanelColor ;
                              if not FShowcaption then  Items[i].Labels.Visible :=False;


                           //Cpl̏ɃC[Wp̃pl쐬
                           Items[i].ChildPanels :=TPanel.Create(MyOwner);
                           Items[i].ChildPanels.BevelInner :=bvLowered;
                           Items[i].ChildPanels.BevelOuter :=bvLowered;
                           Items[i].ChildPanels.Parent := Items[i].MainPanels;

                           if FShowcaption then
                           begin
                             Items[i].ChildPanels.Width  :=Items[i].MainPanels.Width -8;
                             Items[i].ChildPanels.Left   :=4;
                             Items[i].ChildPanels.Height :=(Items[i].MainPanels.Height-8)-20  ;
                             Items[i].ChildPanels.Top    :=4;
                           end
                           else
                           begin
                             Items[i].ChildPanels.Width  :=Items[i].MainPanels.Width -8;
                             Items[i].ChildPanels.Left   :=4;
                             Items[i].ChildPanels.Height :=Items[i].MainPanels.Height -8;
                             Items[i].ChildPanels.Top    :=4;
                           end;

                           Items[i].ChildPanels.Color  :=FPanelColor;
                           Items[i].ChildPanels.OnClick :=OnObjectClick;
                           Items[i].ChildPanels.OnDblClick :=OnObjectDblClick;
                           Items[i].ChildPanels.OnMouseMove :=  OnHotTrack ;
                           Items[i].ChildPanels.OnMouseDown :=OnItemMouseDownEX;
                           Items[i].ChildPanels.OnMouseUp :=OnItemMouseUpEX;

                           Items[i].VeiwImage        :=TPaintBox.Create(MyOwner);
                           Items[i].VeiwImage.Parent :=Items[i].ChildPanels;
                           Items[i].VeiwImage.Align  :=alClient;
                         //  Items[i].VeiwImage.Center:=True;
                           Items[i].VeiwImage.OnClick :=OnObjectClick;
                           Items[i].VeiwImage.OnDblClick :=OnObjectDblClick;
                           Items[i].VeiwImage.OnMouseMove := OnHotTrack ;
                           Items[i].VeiwImage.OnMouseDown :=OnItemMouseDownEX;
                           Items[i].VeiwImage.OnMouseUp :=OnItemMouseUpEX;
                           Items[i].VeiwImage.Tag:=i;
                           Items[i].VeiwImage.onPaint :=OnPiantEx;
                        //   Items[i].VeiwImage.Picture.Assign(Items[i].FImage);
                          { if Items[i].FImage<>nil then
                           begin
                              if (Items[i].FImage.Width>Items[i].ChildPanels.Width)  or
                                 (Items[i].FImage.Height>Items[i].ChildPanels.Height)  then
                              begin
                                 Items[i].VeiwImage.Stretch:=True;
                                 Items[i].VeiwImage.Picture.Assign(Items[i].FImage);
                              end
                              else
                              begin
                                 Items[i].VeiwImage.Center:=True;
                                 Items[i].VeiwImage.Picture.Assign(Items[i].FImage);
                              end;
                           end;
                           }
                 //  if Assigned(CreateViewerCallBack) then CreateViewerCallBack(0,100,Muldiv(i,100,Items.Count-1 ),False);
                 end;{end  for}

   // if Assigned(CreateViewerCallBack) then CreateViewerCallBack(0,0,0,True);
end;
end.
