//==============================================================================
//
//           u߂ˋ@\tTImagev
//
//==============================================================================
//                                 Copyright 2000 Takeshi Okamoto(PAPY)
//                                 papy@hamal.freemail.ne.jp
//                                 http://homepage1.nifty.com/MADIA/ (Japanese)
//==============================================================================
//                                                                   Version 1.1
//==============================================================================
//
// Version 1.00     J@2000-09-16
//         1.1           @ 2000-09-30
//
//==============================================================================


unit MGI;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Forms, ExtCtrls;

type

  TMagnification =(M1,M2,M3,M4,M5,M6,M7,M8,M9,M10);
  TMagnifyingGlassImage = class(TImage)

  private
    { Private 錾 }
     MyOwner           :  TForm                  ;
     DisplayWidth      :  integer                ;
     DisplayHeight     :  integer                ;
     PaintFlag         :  Boolean                ;
     MFN               :  Integer                ;

     FMagnification    :  TMagnification         ;
     FTurn             :  Boolean                ;
     FTimer            :  TTimer                 ;
     FMGIEnabled       :  Boolean                ;

     procedure      SetMagnification(Value: TMagnification) ;
     procedure      SetInterval(AInterval: Cardinal	)   ;
     procedure      SetMGIEnabled(Value: Boolean)           ;
     procedure      SetTurn(Value: Boolean)                 ;
     function       GetInterval: Cardinal	            ;


  protected
    { Protected 錾 }
     Procedure      Loaded; Override;
     procedure      UpdateImage(Sender: TObject)                 ;  
  public
    { Public 錾 }
    constructor    Create(AOwner: TComponent); override;
    destructor     Destroy; override;
  published
    { Published 錾 }
    property       Turn          : Boolean        read FTurn           write SetTurn        ;
    property       Interval      : Cardinal	  read GetInterval     write SetInterval    ;
    property       MGIEnabled    : Boolean        read FMGIEnabled     write SetMGIEnabled  ;
    property       Magnification : TMagnification read FMagnification  write SetMagnification ;
    property       Color;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('PAPY', [TMagnifyingGlassImage]);
end;


////////////////////////////////////////////////////////////////////////////////


///////////
constructor TMagnifyingGlassImage.Create(AOwner: TComponent);
begin

  inherited Create(AOwner);

  with AOwner as TForm do
  MyOwner := TForm(AOwner);

  FTimer          := TTimer.Create(Self)               ;
  FTimer.Interval := 100                               ;
  FMGIEnabled     := True                              ;
  FMagnification  := M2                                ;

  MFN             := 2                                 ;
  DisplayWidth    := GetSystemMetrics(SM_CXSCREEN)     ;
  DisplayHeight   := GetSystemMetrics(SM_CYSCREEN)     ;
  PaintFlag       := False                             ;

end;


//////////
destructor TMagnifyingGlassImage.Destroy;
begin

  FTimer.Free;
  inherited Destroy;

end;

/////////
Procedure   TMagnifyingGlassImage. Loaded;
begin

{ ݌vɓ]܂ĂƍĐisjoȂisHĵŎgp}

  If (csDesigning in ComponentState)  then  Exit;

  FTimer.OnTimer  := UpdateImage ;


end;
/////////
procedure  TMagnifyingGlassImage.SetMGIEnabled(Value: Boolean);
begin

   FMGIEnabled       :=  Value    ;
   FTimer.Enabled    :=  FMGIEnabled ;

end;

/////////
procedure  TMagnifyingGlassImage.SetInterval(AInterval: Cardinal) ;
begin

   FTimer.Interval := AInterval;

end;

////////
function  TMagnifyingGlassImage.GetInterval: Cardinal;
begin

  Result := FTimer.Interval;

end;

/////////
procedure TMagnifyingGlassImage.SetTurn(Value: Boolean) ;
begin

    FTurn :=Value;

end;

/////////
procedure TMagnifyingGlassImage.SetMagnification(Value: TMagnification) ;
begin

  if FMagnification <> Value then
  begin
    FMagnification:= Value;

      case FMagnification of
        M1   : MFN :=1;
        M2   : MFN :=2;
        M3   : MFN :=3;
        M4   : MFN :=4;
        M5   : MFN :=5;
        M6   : MFN :=6;
        M7   : MFN :=7;
        M8   : MFN :=8;
        M9   : MFN :=9;
        M10  : MFN :=10;
      end;

  end;

end;

/////////
procedure  TMagnifyingGlassImage.UpdateImage(Sender: TObject);
Var
Poi : Tpoint  ;
DC  : Integer ;
begin


    ///////////////////̗///////////////////////////
    //                                                      //
    // @}EXJ[\ӂ̉摜擾Ďgɓ]}  //
    //                                                      //
    // Agɓ]ꂽ摜g債Ďgɓ]}  //
    //                                                      //
    // B@.ǍJԂ@                                  //
    //                                                      //
    // xAɓ]H()}      //
    //                                                      //
    //////////////////////////////////////////////////////////


     GetCursorPos(Poi) ;
     DC := GetWindowDC(GetCapture);

   {ʂ̍[Ƀ}EXJ[\ꍇ}

      if Poi.x <= Self.width div (MFN * 2 )  then
      begin

           BitBlt(Self.Canvas.Handle, 0, 0, Self.Width div MFN , Self.Height div MFN  ,
                  DC,0,poi.y-(Self.Height div (MFN * 2)) , SRCCOPY);

           PaintFlag :=True;


      end;

   {ʂ̉E[Ƀ}EXJ[\ꍇ}

      if Poi.X >=DisplayWidth-(Self.Width div (MFN * 2) )  then
      begin

           BitBlt(Self.Canvas.Handle, 0, 0, Self.Width div MFN  , Self.Height div MFN ,
             DC,DisplayWidth -(Self.Width div MFN),Poi.Y-(Self.Height div (MFN * 2)) , SRCCOPY);

           PaintFlag :=True;

      end;


  {ʂ̏Ƀ}EXJ[\ꍇ}

      if  Poi.Y <= (Self.Height div (MFN * 2) ) then
      begin

          BitBlt(Self.Canvas.Handle, 0, 0, Self.Width  div MFN, Self.Height div MFN ,
                  DC,poi.x-(Self.Width div (MFN * 2)),0, SRCCOPY);

          PaintFlag :=True;

      end;

  {ʂ̉Ƀ}EXJ[\ꍇ}

     if Poi.Y >=DisplayHeight-(Self.Height div (MFN * 2) )  then
     begin

         BitBlt(Self.Canvas.Handle, 0, 0, Self.Width div MFN , Self.Height div MFN  ,
                DC,poi.x-(Self.Width div (MFN * 2)),DisplayHeight -(Self.Height div MFN ) , SRCCOPY);

         PaintFlag :=True;
     end;


  {ʂ̍Ƀ}EXJ[\ꍇ}

    if Poi.x <= Self.Width div (MFN * 2)     then
    begin
       if  Poi.Y <= (Self.Height div (MFN * 2) ) then
       begin

         BitBlt(Self.Canvas.Handle, 0, 0, Self.Width div MFN , Self.Height div MFN  ,
                DC,0,0 , SRCCOPY);

         PaintFlag :=True;
       end;

    end;

  {ʂ̍Ƀ}EXJ[\ꍇ}

    if Poi.x <= Self.Width div (MFN * 2)     then
    begin
       if Poi.Y >=DisplayHeight-(Self.Height div (MFN * 2) )  then
       begin

         BitBlt(Self.Canvas.Handle, 0, 0, Self.Width div MFN , Self.Height div MFN  ,
                DC,0,poi.y-(Self.Height div MFN ), SRCCOPY);

         PaintFlag :=True;
       end;

    end;

  {ʂ̉EɃ}EXJ[\ꍇ}

    if Poi.X >=DisplayWidth-(Self.Width div (MFN * 2) )  then
    begin
       if  Poi.Y <= (Self.Height div (MFN * 2) ) then
       begin

         BitBlt(Self.Canvas.Handle, 0, 0, Self.Width div MFN, Self.Height div MFN ,
                DC,poi.x-(Self.width div MFN ),0, SRCCOPY);

         PaintFlag :=True;
       end;

    end;

  {ʂ̉EɃ}EXJ[\ꍇ}

    if Poi.X >=DisplayWidth-(Self.Width div (MFN * 2) )  then
    begin
       if Poi.Y >=DisplayHeight-(Self.Height div (MFN * 2) )  then
       begin

         BitBlt(Self.Canvas.Handle, 0, 0, Self.Width div MFN  , Self.Height div MFN  ,
                DC,poi.x-(Self.width div MFN  ),poi.y-(Self.Height div MFN ), SRCCOPY);

         PaintFlag :=True;
       end;

    end;



  {c̏ꏊɃ}EXJ[\ꍇ}

    if not PaintFlag  then
    begin

          BitBlt(Self.Canvas.Handle, 0, 0, Self.Width div MFN, Self.Height div MFN  ,
          DC,poi.x-(Self.Width div (MFN * 2)),poi.y-(Self.Height div (MFN * 2)) , SRCCOPY);


    end;

  {摜𔽓]̂H}
    if  FTurn then

          StretchBlt(Self.Canvas.Handle, 0, 0, Self.Width, Self.Height,
               Self.Canvas.Handle, 0, 0, Self.Width div MFN  ,
                 Self.Height div MFN , NOTSRCCOPY )

    else

          StretchBlt(Self.Canvas.Handle, 0, 0, Self.Width, Self.Height,
              Self.Canvas.Handle, 0, 0, Self.Width div MFN  ,
                Self.Height div MFN  , SRCCOPY) ;



   Self.Refresh;
   PaintFlag :=False;

  {Ԃɔ΂i΁j}
   DeleteDC(DC);
   ReleaseDC(MyOwner.Handle, DC) ;


end;

end.
