//==============================================================================
//
//           uMIDIgĉtv
//
//==============================================================================
//                                 Copyright 2000 Takeshi Okamoto(PAPY)
//                                 papy@hamal.freemail.ne.jp
//                                 http://homepage1.nifty.com/MADIA/ (Japanese)
//==============================================================================
//                                                                   Version 1.1
//==============================================================================
//
// Version 1.00     J@2000-09
//         1.1           @ 2000-09-30
//         1.2              2000-01-16
//                                MIDI޲IDԈႦĂ̂C
//                                (u-1v -> u0v)
//
//==============================================================================

unit MidiPlay;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,MMsystem ;

type

 //y
  TInstrument = (Piano_Acoustic_Grand    ,
                 Piano_Bright_Acoustic   ,
                 Piano_Electric          ,
                 Piano_Honky_Tonk        ,
                 Piano_Electric1         ,
                 Piano_Electric2         ,
                 Harpsichord             ,
                 Clavinet                ,
                 Celesta                 ,
                 Glockenspiel            ,
                 Music_Box               ,
                 Vibraphone              ,
                 Marimba                 ,
                 Xylophone               ,
                 Tubular_Bells           ,
                 Dulcimer                ,
                 Organ_Drawbar           ,
                 Organ_Percussive        ,
                 Organ_Rock              ,
                 Organ_Church            ,
                 Organ_Reed              ,
                 Accordion               ,
                 Harmonica               ,
                 Tango_Accordion         ,
                 Guitar_Acoustic1        ,
                 Guitar_Acoustic2        ,
                 Guitar_Electric1        ,
                 Guitar_Electric2        ,
                 Guitar_Electric3        ,
                 Guitar_Overdrive        ,
                 Guitar_Distortion       ,
                 Guitar_Harmonics        ,
                 Bass_Acoustic           ,
                 Bass_Electric_Finger    ,
                 Bass_Electric_Pick      ,
                 Bass_Fretless           ,
                 Bass_Slap1              ,
                 Bass_Slap2              ,
                 Bass_Synth1             ,
                 Bass_Synth2             ,
                 Violin                  ,
                 Viola                   ,
                 Cello                   ,
                 Contrabass              ,
                 Tremolo_Strings         ,
                 izzicato_Strings        ,
                 Orchestral_Harp         ,
                 Timpani                 ,
                 String_Ensemble1        ,
                 String_Ensemble2        ,
                 Synth_Strings1          ,
                 Synth_Strings2          ,
                 Choir_Aahs              ,
                 Voice_Oohs              ,
                 Synth_Voice             ,
                 Orchestra_Hit           ,
                 Trumpet                 ,
                 Trombone                ,
                 Tuba                    ,
                 Muted_Trumpet           ,
                 French_Horn             ,
                 Brass_Section           ,
                 Synth_Brass1            ,
                 Synth_Brass2            ,
                 Sax_Soprano             ,
                 Sax_Alto                ,
                 Sax_Tenor               ,
                 Sax_Baritone            ,
                 Oboe                    ,
                 English_Hom             ,
                 Bassoon                 ,
                 Clarinet                ,
                 Piccolo                 ,
                 Flute                   ,
                 Recorder                ,
                 Pan_Flute               ,
                 Blown_Bottle            ,
                 Shakuhachi              ,
                 Whistle                 ,
                 Ocarina                 ,
                 Lead_Square             ,
                 Lead_Sawtooth           ,
                 Lead_Calliope           ,
                 Lead_Chiff              ,
                 Lead_Charang            ,
                 Lead_Voice              ,
                 Lead_Fifths             ,
                 Lead_BassLead          ,
                 Lead_Fantasia           ,
                 Pad_Warm                ,
                 Pad_Polysynth           ,
                 Pad_Choir               ,
                 Pad_Bowed               ,
                 Pad_Metallic            ,
                 Pad_Halo                ,
                 Pad_Sweep               ,
                 FX_IceRain              ,
                 FX_Soundtrack           ,
                 FX_Crystal              ,
                 FX_Atmosphere           ,
                 FX_Brightness           ,
                 FX_Goblins              ,
                 FX_Echoes               ,
                 FX_Star                 ,
                 Sitar                   ,
                 Banjo                   ,
                 Shamisen                ,
                 Koto                    ,
                 Kalimba                 ,
                 Bagpipe                 ,
                 Fiddle                  ,
                 Shanai                  ,
                 Tinkle_Bell             ,
                 Agogo                   ,
                 Steel_Drums             ,
                 Woodblock               ,
                 Taiko_Drum              ,
                 Melodic_Tom             ,
                 Synth_Drum              ,
                 Reverse_Cymbal          ,
                 Guitar_Fret_Noise       ,
                 Breath_Noise            ,
                 Seashore                ,
                 Bird_Tweet              ,
                 Telephone               ,
                 Helicopter              ,
                 Applause                ,
                 Gunshot
                 );


  TMidiPlay = class(TComponent)

  private
    { Private 錾 }


    hMidi        : integer;      //Midĩnh
    MidiMsg      : Integer;      //Midỉ



    FInstrument  : TInstrument;  //y
    FMidiDevice  : Boolean;      //Midigp\H

    procedure SetMidiDevice     (Value : Boolean)    ;
    procedure MusicOn           (Value : integer)    ;
    procedure MusicOff          (Value : integer)    ;
    procedure MusicChange                            ;
    procedure SetInstrument     (Value : TInstrument);


  protected
    { Protected 錾 }
  public
    { Public 錾 }

    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; override;

    function    MidiPortOpen : Boolean;
    procedure   MidiPortClose;


    //炷
    procedure   Keyboard1_On;
    procedure   Keyboard2_On;
    procedure   Keyboard3_On;
    procedure   Keyboard4_On;
    procedure   Keyboard5_On;

    procedure   Keyboard6_On;
    procedure   Keyboard7_On;
    procedure   Keyboard8_On;
    procedure   Keyboard9_On;
    procedure   Keyboard10_On;

    procedure   Keyboard11_On;
    procedure   Keyboard12_On;
    procedure   Keyboard13_On;
    procedure   Keyboard14_On;
    procedure   Keyboard15_On;

    procedure   Keyboard16_On;
    procedure   Keyboard17_On;
    procedure   Keyboard18_On;
    procedure   Keyboard19_On;
    procedure   Keyboard20_On;

    procedure   Keyboard21_On;
    procedure   Keyboard22_On;
    procedure   Keyboard23_On;
    procedure   Keyboard24_On;
    procedure   Keyboard25_On;

    procedure   Keyboard26_On;
    procedure   Keyboard27_On;
    procedure   Keyboard28_On;
    procedure   Keyboard29_On;
    procedure   Keyboard30_On;

    procedure   Keyboard31_On;
    procedure   Keyboard32_On;
    procedure   Keyboard33_On;
    procedure   Keyboard34_On;
    procedure   Keyboard35_On;

    procedure   Keyboard36_On;
    procedure   Keyboard37_On;
    procedure   Keyboard38_On;
    procedure   Keyboard39_On;
    procedure   Keyboard40_On;

    procedure   Keyboard41_On;
    procedure   Keyboard42_On;
    procedure   Keyboard43_On;
    procedure   Keyboard44_On;
    procedure   Keyboard45_On;

    procedure   Keyboard46_On;
    procedure   Keyboard47_On;
    procedure   Keyboard48_On;
    procedure   Keyboard49_On;
    procedure   Keyboard50_On;

    procedure   Keyboard51_On;
    procedure   Keyboard52_On;
    procedure   Keyboard53_On;
    procedure   Keyboard54_On;
    procedure   Keyboard55_On;

    procedure   Keyboard56_On;
    procedure   Keyboard57_On;
    procedure   Keyboard58_On;
    procedure   Keyboard59_On;
    procedure   Keyboard60_On;

    //Ƃ߂
    procedure   Keyboard1_Off;
    procedure   Keyboard2_Off;
    procedure   Keyboard3_Off;
    procedure   Keyboard4_Off;
    procedure   Keyboard5_Off;

    procedure   Keyboard6_Off;
    procedure   Keyboard7_Off;
    procedure   Keyboard8_Off;
    procedure   Keyboard9_Off;
    procedure   Keyboard10_Off;

    procedure   Keyboard11_Off;
    procedure   Keyboard12_Off;
    procedure   Keyboard13_Off;
    procedure   Keyboard14_Off;
    procedure   Keyboard15_Off;

    procedure   Keyboard16_Off;
    procedure   Keyboard17_Off;
    procedure   Keyboard18_Off;
    procedure   Keyboard19_Off;
    procedure   Keyboard20_Off;

    procedure   Keyboard21_Off;
    procedure   Keyboard22_Off;
    procedure   Keyboard23_Off;
    procedure   Keyboard24_Off;
    procedure   Keyboard25_Off;

    procedure   Keyboard26_Off;
    procedure   Keyboard27_Off;
    procedure   Keyboard28_Off;
    procedure   Keyboard29_Off;
    procedure   Keyboard30_Off;

    procedure   Keyboard31_Off;
    procedure   Keyboard32_Off;
    procedure   Keyboard33_Off;
    procedure   Keyboard34_Off;
    procedure   Keyboard35_Off;

    procedure   Keyboard36_Off;
    procedure   Keyboard37_Off;
    procedure   Keyboard38_Off;
    procedure   Keyboard39_Off;
    procedure   Keyboard40_Off;

    procedure   Keyboard41_Off;
    procedure   Keyboard42_Off;
    procedure   Keyboard43_Off;
    procedure   Keyboard44_Off;
    procedure   Keyboard45_Off;

    procedure   Keyboard46_Off;
    procedure   Keyboard47_Off;
    procedure   Keyboard48_Off;
    procedure   Keyboard49_Off;
    procedure   Keyboard50_Off;

    procedure   Keyboard51_Off;
    procedure   Keyboard52_Off;
    procedure   Keyboard53_Off;
    procedure   Keyboard54_Off;
    procedure   Keyboard55_Off;

    procedure   Keyboard56_Off;
    procedure   Keyboard57_Off;
    procedure   Keyboard58_Off;
    procedure   Keyboard59_Off;
    procedure   Keyboard60_Off;




  published
    { Published 錾 }

    property MidiDevice : Boolean     read  FMidiDevice write SetMidiDevice;

    property Instrument : TInstrument read FInstrument  write SetInstrument default Piano_Acoustic_Grand;

  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('PAPY', [TMidiPlay]);
end;




////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////





constructor TMidiPlay.Create(AOwner: TComponent);
Var

 Ret : Integer;

begin
  inherited Create(AOwner);

  //MidifoCX擾
   Ret := midiOutGetNumDevs;

   if  Ret<=0 then
    FMidiDevice :=False
   else
    FMidiDevice :=True;

end;


destructor TMidiPlay.Destroy;
begin

   //MIdi|[g
    MidiPortClose;

   inherited Destroy;

end;

////////////////////////////////////////////////////////////////////////////////

//Midigpł邩̃tO
procedure TMidiPlay.SetMidiDevice ;
begin
end;


//Midi|[gJ
function  TMidiPlay.MidiPortOpen : Boolean;
Var
Ret : integer;
begin

 //ɊJĂꍇ̂Ń|[g
    midiOutClose(hMidi);

   //Midi|[gJ
    Ret :=midiOutOpen(@hMidi, 0, 0, 0, 0);

    if Ret = 0 then
    begin

        Result := True;

       //yݒ
        MusicChange;

    end
    else

        Result :=False;

end;



procedure TMidiPlay.MidiPortClose;
begin

  //MIDIo߰ẴZbg
    MidiOutReset(hMidi);

  //MIDIo̓|[g
    MidiOutClose(hMidi);

end;

//o
procedure TMidiPlay.MusicOn;
begin

 if hMidi<>0 then
 begin

   MidiMsg := $790090 + (60 + Value) * $100 ;

   midiOutShortMsg(hMidi, MidiMsg) ;

 end;

end;

//Ƃ߂
procedure TMidiPlay.MusicOff;
begin

 if hMidi<>0 then
 begin

   MidiMsg := $100080 + (60 + (Value)) * $100;

   midiOutShortMsg(hMidi, MidiMsg)

 end;

end;


//yύX(vpeB)
procedure TMidiPlay.SetInstrument(Value: TInstrument);
begin

  if FInstrument <> Value then
  begin
    FInstrument:= Value;

         if hMidi<>0 then

          //yύX
            MusicChange ;


  end;

end;





procedure   TMidiPlay.Keyboard1_On;
begin
  MusicOn(-36)  ;
end;

procedure   TMidiPlay.Keyboard2_On;
begin
  MusicOn(-35)  ;
end;

procedure   TMidiPlay.Keyboard3_On;
begin
  MusicOn(-34)  ;
end;

procedure   TMidiPlay.Keyboard4_On;
begin
  MusicOn(-33)  ;
end;

procedure   TMidiPlay.Keyboard5_On;
begin
  MusicOn(-32)  ;
end;

procedure   TMidiPlay.Keyboard6_On;
begin
  MusicOn(-31)  ;
end;

procedure   TMidiPlay.Keyboard7_On;
begin
  MusicOn(-30)  ;
end;

procedure   TMidiPlay.Keyboard8_On;
begin
  MusicOn(-29)  ;
end;

procedure   TMidiPlay.Keyboard9_On;
begin
  MusicOn(-28)  ;
end;

procedure   TMidiPlay.Keyboard10_On;
begin
  MusicOn(-27)  ;
end;

procedure   TMidiPlay.Keyboard11_On;
begin
  MusicOn(-26)  ;
end;

procedure   TMidiPlay.Keyboard12_On;
begin
  MusicOn(-25)  ;
end;

procedure   TMidiPlay.Keyboard13_On;
begin
  MusicOn(-24)  ;
end;

procedure   TMidiPlay.Keyboard14_On;
begin
  MusicOn(-23)  ;
end;

procedure   TMidiPlay.Keyboard15_On;
begin
  MusicOn(-22)  ;
end;

procedure   TMidiPlay.Keyboard16_On;
begin
  MusicOn(-21)  ;
end;

procedure   TMidiPlay.Keyboard17_On;
begin
  MusicOn(-20)  ;
end;

procedure   TMidiPlay.Keyboard18_On;
begin
  MusicOn(-19)  ;
end;

procedure   TMidiPlay.Keyboard19_On;
begin
  MusicOn(-18)  ;
end;

procedure   TMidiPlay.Keyboard20_On;
begin
  MusicOn(-17)  ;
end;

procedure   TMidiPlay.Keyboard21_On;
begin
  MusicOn(-16)  ;
end;

procedure   TMidiPlay.Keyboard22_On;
begin
  MusicOn(-15)  ;
end;

procedure   TMidiPlay.Keyboard23_On;
begin
  MusicOn(-14)  ;
end;

procedure   TMidiPlay.Keyboard24_On;
begin
  MusicOn(-13)  ;
end;

procedure   TMidiPlay.Keyboard25_On;
begin
  MusicOn(-12)  ;
end;

procedure   TMidiPlay.Keyboard26_On;
begin
  MusicOn(-11)  ;
end;

procedure   TMidiPlay.Keyboard27_On;
begin
  MusicOn(-10)  ;
end;

procedure   TMidiPlay.Keyboard28_On;
begin
  MusicOn(-9)  ;
end;

procedure   TMidiPlay.Keyboard29_On;
begin
  MusicOn(-8)  ;
end;

procedure   TMidiPlay.Keyboard30_On;
begin
  MusicOn(-7)  ;
end;

procedure   TMidiPlay.Keyboard31_On;
begin
  MusicOn(-6)  ;
end;

procedure   TMidiPlay.Keyboard32_On;
begin
  MusicOn(-5)  ;
end;

procedure   TMidiPlay.Keyboard33_On;
begin
  MusicOn(-4)  ;
end;

procedure   TMidiPlay.Keyboard34_On;
begin
  MusicOn(-3)  ;
end;

procedure   TMidiPlay.Keyboard35_On;
begin
  MusicOn(-2)  ;
end;

procedure   TMidiPlay.Keyboard36_On;
begin
  MusicOn(-1)  ;
end;

procedure   TMidiPlay.Keyboard37_On;
begin
  MusicOn(0)  ;
end;

procedure   TMidiPlay.Keyboard38_On;
begin
  MusicOn(1)  ;
end;

procedure   TMidiPlay.Keyboard39_On;
begin
  MusicOn(2)  ;
end;

procedure   TMidiPlay.Keyboard40_On;
begin
  MusicOn(3)  ;
end;

procedure   TMidiPlay.Keyboard41_On;
begin
  MusicOn(4)  ;
end;

procedure   TMidiPlay.Keyboard42_On;
begin
  MusicOn(5)  ;
end;

procedure   TMidiPlay.Keyboard43_On;
begin
  MusicOn(6)  ;
end;

procedure   TMidiPlay.Keyboard44_On;
begin
  MusicOn(7)  ;
end;

procedure   TMidiPlay.Keyboard45_On;
begin
  MusicOn(8)  ;
end;

procedure   TMidiPlay.Keyboard46_On;
begin
  MusicOn(9)  ;
end;

procedure   TMidiPlay.Keyboard47_On;
begin
  MusicOn(10)  ;
end;

procedure   TMidiPlay.Keyboard48_On;
begin
  MusicOn(11)  ;
end;

procedure   TMidiPlay.Keyboard49_On;
begin
  MusicOn(12)  ;
end;

procedure   TMidiPlay.Keyboard50_On;
begin
  MusicOn(13)  ;
end;

procedure   TMidiPlay.Keyboard51_On;
begin
  MusicOn(14)  ;
end;

procedure   TMidiPlay.Keyboard52_On;
begin
  MusicOn(15)  ;
end;

procedure   TMidiPlay.Keyboard53_On;
begin
  MusicOn(16)  ;
end;

procedure   TMidiPlay.Keyboard54_On;
begin
  MusicOn(17)  ;
end;

procedure   TMidiPlay.Keyboard55_On;
begin
  MusicOn(18)  ;
end;

procedure   TMidiPlay.Keyboard56_On;
begin
  MusicOn(19)  ;
end;

procedure   TMidiPlay.Keyboard57_On;
begin
  MusicOn(20)  ;
end;

procedure   TMidiPlay.Keyboard58_On;
begin
  MusicOn(21)  ;
end;

procedure   TMidiPlay.Keyboard59_On;
begin
  MusicOn(22)  ;
end;

procedure   TMidiPlay.Keyboard60_On;
begin
  MusicOn(23)  ;
end;



//Ƃ߂
procedure   TMidiPlay.Keyboard1_Off;
begin
  MusicOff(-36)  ;
end;

procedure   TMidiPlay.Keyboard2_Off;
begin
  MusicOff(-35)  ;
end;

procedure   TMidiPlay.Keyboard3_Off;
begin
  MusicOff(-34)  ;
end;

procedure   TMidiPlay.Keyboard4_Off;
begin
  MusicOff(-33)  ;
end;

procedure   TMidiPlay.Keyboard5_Off;
begin
  MusicOff(-32)  ;
end;

procedure   TMidiPlay.Keyboard6_Off;
begin
  MusicOff(-31)  ;
end;

procedure   TMidiPlay.Keyboard7_Off;
begin
  MusicOff(-30)  ;
end;

procedure   TMidiPlay.Keyboard8_Off;
begin
  MusicOff(-29)  ;
end;

procedure   TMidiPlay.Keyboard9_Off;
begin
  MusicOff(-28)  ;
end;

procedure   TMidiPlay.Keyboard10_Off;
begin
  MusicOff(-27)  ;
end;

procedure   TMidiPlay.Keyboard11_Off;
begin
  MusicOff(-26)  ;
end;

procedure   TMidiPlay.Keyboard12_Off;
begin
  MusicOff(-25)  ;
end;

procedure   TMidiPlay.Keyboard13_Off;
begin
  MusicOff(-24)  ;
end;

procedure   TMidiPlay.Keyboard14_Off;
begin
  MusicOff(-23)  ;
end;

procedure   TMidiPlay.Keyboard15_Off;
begin
  MusicOff(-22)  ;
end;

procedure   TMidiPlay.Keyboard16_Off;
begin
  MusicOff(-21)  ;
end;

procedure   TMidiPlay.Keyboard17_Off;
begin
  MusicOff(-20)  ;
end;

procedure   TMidiPlay.Keyboard18_Off;
begin
  MusicOff(-19)  ;
end;

procedure   TMidiPlay.Keyboard19_Off;
begin
  MusicOff(-18)  ;
end;

procedure   TMidiPlay.Keyboard20_Off;
begin
  MusicOff(-17)  ;
end;

procedure   TMidiPlay.Keyboard21_Off;
begin
  MusicOff(-16)  ;
end;

procedure   TMidiPlay.Keyboard22_Off;
begin
  MusicOff(-15)  ;
end;

procedure   TMidiPlay.Keyboard23_Off;
begin
  MusicOff(-14)  ;
end;

procedure   TMidiPlay.Keyboard24_Off;
begin
  MusicOff(-13)  ;
end;

procedure   TMidiPlay.Keyboard25_Off;
begin
  MusicOff(-12)  ;
end;

procedure   TMidiPlay.Keyboard26_Off;
begin
  MusicOff(-11)  ;
end;

procedure   TMidiPlay.Keyboard27_Off;
begin
  MusicOff(-10)  ;
end;

procedure   TMidiPlay.Keyboard28_Off;
begin
  MusicOff(-9)  ;
end;

procedure   TMidiPlay.Keyboard29_Off;
begin
  MusicOff(-8)  ;
end;

procedure   TMidiPlay.Keyboard30_Off;
begin
  MusicOff(-7)  ;
end;

procedure   TMidiPlay.Keyboard31_Off;
begin
  MusicOff(-6)  ;
end;

procedure   TMidiPlay.Keyboard32_Off;
begin
  MusicOff(-5)  ;
end;

procedure   TMidiPlay.Keyboard33_Off;
begin
  MusicOff(-4)  ;
end;

procedure   TMidiPlay.Keyboard34_Off;
begin
  MusicOff(-3)  ;
end;

procedure   TMidiPlay.Keyboard35_Off;
begin
  MusicOff(-2)  ;
end;

procedure   TMidiPlay.Keyboard36_Off;
begin
  MusicOff(-1)  ;
end;

procedure   TMidiPlay.Keyboard37_Off;
begin
  MusicOff(0)  ;
end;

procedure   TMidiPlay.Keyboard38_Off;
begin
  MusicOff(1)  ;
end;

procedure   TMidiPlay.Keyboard39_Off;
begin
  MusicOff(2)  ;
end;

procedure   TMidiPlay.Keyboard40_Off;
begin
  MusicOff(3)  ;
end;

procedure   TMidiPlay.Keyboard41_Off;
begin
  MusicOff(4)  ;
end;

procedure   TMidiPlay.Keyboard42_Off;
begin
  MusicOff(5)  ;
end;

procedure   TMidiPlay.Keyboard43_Off;
begin
  MusicOff(6)  ;
end;

procedure   TMidiPlay.Keyboard44_Off;
begin
  MusicOff(7)  ;
end;

procedure   TMidiPlay.Keyboard45_Off;
begin
  MusicOff(8)  ;
end;

procedure   TMidiPlay.Keyboard46_Off;
begin
  MusicOff(9)  ;
end;

procedure   TMidiPlay.Keyboard47_Off;
begin
  MusicOff(10)  ;
end;

procedure   TMidiPlay.Keyboard48_Off;
begin
  MusicOff(11)  ;
end;

procedure   TMidiPlay.Keyboard49_Off;
begin
  MusicOff(12)  ;
end;

procedure   TMidiPlay.Keyboard50_Off;
begin
  MusicOff(13)  ;
end;

procedure   TMidiPlay.Keyboard51_Off;
begin
  MusicOff(14)  ;
end;

procedure   TMidiPlay.Keyboard52_Off;
begin
  MusicOff(15)  ;
end;

procedure   TMidiPlay.Keyboard53_Off;
begin
  MusicOff(16)  ;
end;

procedure   TMidiPlay.Keyboard54_Off;
begin
  MusicOff(17)  ;
end;

procedure   TMidiPlay.Keyboard55_Off;
begin
  MusicOff(18)  ;
end;

procedure   TMidiPlay.Keyboard56_Off;
begin
  MusicOff(19)  ;
end;

procedure   TMidiPlay.Keyboard57_Off;
begin
  MusicOff(20)  ;
end;

procedure   TMidiPlay.Keyboard58_Off;
begin
  MusicOff(21)  ;
end;

procedure   TMidiPlay.Keyboard59_Off;
begin
  MusicOff(22)  ;
end;

procedure   TMidiPlay.Keyboard60_Off;
begin
  MusicOff(23)  ;
end;




//yύXiۂɕύXj
procedure TMidiPlay.MusicChange;
Var
Ret : integer;
begin

if hMidi=0 then Exit;
  Ret :=0;
Case FInstrument of

   Piano_Acoustic_Grand   : Ret := $C0 + 0 * $100   ;
   Piano_Bright_Acoustic  : Ret := $C0 + 1 * $100   ;
   Piano_Electric         : Ret := $C0 + 2 * $100   ;
   Piano_Honky_Tonk       : Ret := $C0 + 3 * $100   ;
   Piano_Electric1        : Ret := $C0 + 4 * $100   ;
   Piano_Electric2        : Ret := $C0 + 5 * $100   ;
   Harpsichord            : Ret := $C0 + 6 * $100   ;
   Clavinet               : Ret := $C0 + 7 * $100   ;
   Celesta                : Ret := $C0 + 8 * $100   ;
   Glockenspiel           : Ret := $C0 + 9 * $100   ;
   Music_Box              : Ret := $C0 + 10 * $100   ;
   Vibraphone             : Ret := $C0 + 11 * $100   ;
   Marimba                : Ret := $C0 + 12 * $100   ;
   Xylophone              : Ret := $C0 + 13 * $100   ;
   Tubular_Bells          : Ret := $C0 + 14 * $100   ;
   Dulcimer               : Ret := $C0 + 15 * $100   ;
   Organ_Drawbar          : Ret := $C0 + 16 * $100   ;
   Organ_Percussive       : Ret := $C0 + 17 * $100   ;
   Organ_Rock             : Ret := $C0 + 18 * $100   ;
   Organ_Church           : Ret := $C0 + 19 * $100   ;
   Organ_Reed             : Ret := $C0 + 20 * $100   ;
   Accordion              : Ret := $C0 + 21 * $100   ;
   Harmonica              : Ret := $C0 + 22 * $100   ;
   Tango_Accordion        : Ret := $C0 + 23 * $100   ;
   Guitar_Acoustic1       : Ret := $C0 + 24 * $100   ;
   Guitar_Acoustic2       : Ret := $C0 + 25 * $100   ;
   Guitar_Electric1       : Ret := $C0 + 26 * $100   ;
   Guitar_Electric2       : Ret := $C0 + 27 * $100   ;
   Guitar_Electric3       : Ret := $C0 + 28 * $100   ;
   Guitar_Overdrive       : Ret := $C0 + 29 * $100   ;
   Guitar_Distortion      : Ret := $C0 + 30 * $100   ;
   Guitar_Harmonics       : Ret := $C0 + 31 * $100   ;
   Bass_Acoustic          : Ret := $C0 + 32 * $100   ;
   Bass_Electric_Finger   : Ret := $C0 + 33 * $100   ;
   Bass_Electric_Pick     : Ret := $C0 + 34 * $100   ;
   Bass_Fretless          : Ret := $C0 + 35 * $100   ;
   Bass_Slap1             : Ret := $C0 + 36 * $100   ;
   Bass_Slap2             : Ret := $C0 + 37 * $100   ;
   Bass_Synth1            : Ret := $C0 + 38 * $100   ;
   Bass_Synth2            : Ret := $C0 + 39 * $100   ;
   Violin                 : Ret := $C0 + 40 * $100   ;
   Viola                  : Ret := $C0 + 41 * $100   ;
   Cello                  : Ret := $C0 + 42 * $100   ;
   Contrabass             : Ret := $C0 + 43 * $100   ;
   Tremolo_Strings        : Ret := $C0 + 44 * $100   ;
   izzicato_Strings       : Ret := $C0 + 45 * $100   ;
   Orchestral_Harp        : Ret := $C0 + 46 * $100   ;
   Timpani                : Ret := $C0 + 47 * $100   ;
   String_Ensemble1       : Ret := $C0 + 48 * $100   ;
   String_Ensemble2       : Ret := $C0 + 49 * $100   ;
   Synth_Strings1         : Ret := $C0 + 50 * $100   ;
   Synth_Strings2         : Ret := $C0 + 51 * $100   ;
   Choir_Aahs             : Ret := $C0 + 52 * $100   ;
   Voice_Oohs             : Ret := $C0 + 53 * $100   ;
   Synth_Voice            : Ret := $C0 + 54 * $100   ;
   Orchestra_Hit          : Ret := $C0 + 55 * $100   ;
   Trumpet                : Ret := $C0 + 56 * $100   ;
   Trombone               : Ret := $C0 + 57 * $100   ;
   Tuba                   : Ret := $C0 + 58 * $100   ;
   Muted_Trumpet          : Ret := $C0 + 59 * $100   ;
   French_Horn            : Ret := $C0 + 60 * $100   ;
   Brass_Section          : Ret := $C0 + 61 * $100   ;
   Synth_Brass1           : Ret := $C0 + 62 * $100   ;
   Synth_Brass2           : Ret := $C0 + 63 * $100   ;
   Sax_Soprano            : Ret := $C0 + 64 * $100   ;
   Sax_Alto               : Ret := $C0 + 65 * $100   ;
   Sax_Tenor              : Ret := $C0 + 66 * $100   ;
   Sax_Baritone           : Ret := $C0 + 67 * $100   ;
   Oboe                   : Ret := $C0 + 68 * $100   ;
   English_Hom            : Ret := $C0 + 69 * $100   ;
   Bassoon                : Ret := $C0 + 70 * $100   ;
   Clarinet               : Ret := $C0 + 71 * $100   ;
   Piccolo                : Ret := $C0 + 72 * $100   ;
   Flute                  : Ret := $C0 + 73 * $100   ;
   Recorder               : Ret := $C0 + 74 * $100   ;
   Pan_Flute              : Ret := $C0 + 75 * $100   ;
   Blown_Bottle           : Ret := $C0 + 76 * $100   ;
   Shakuhachi             : Ret := $C0 + 77 * $100   ;
   Whistle                : Ret := $C0 + 78 * $100   ;
   Ocarina                : Ret := $C0 + 79 * $100   ;
   Lead_Square            : Ret := $C0 + 80 * $100   ;
   Lead_Sawtooth          : Ret := $C0 + 81 * $100   ;
   Lead_Calliope          : Ret := $C0 + 82 * $100   ;
   Lead_Chiff             : Ret := $C0 + 83 * $100   ;
   Lead_Charang           : Ret := $C0 + 84 * $100   ;
   Lead_Voice             : Ret := $C0 + 85 * $100   ;
   Lead_Fifths            : Ret := $C0 + 86 * $100   ;
   Lead_BassLead          : Ret := $C0 + 87 * $100   ;
   Lead_Fantasia          : Ret := $C0 + 88 * $100   ;
   Pad_Warm               : Ret := $C0 + 89 * $100   ;
   Pad_Polysynth          : Ret := $C0 + 90 * $100   ;
   Pad_Choir              : Ret := $C0 + 91 * $100   ;
   Pad_Bowed              : Ret := $C0 + 92 * $100   ;
   Pad_Metallic           : Ret := $C0 + 93 * $100   ;
   Pad_Halo               : Ret := $C0 + 94 * $100   ;
   Pad_Sweep              : Ret := $C0 + 95 * $100   ;
   FX_IceRain             : Ret := $C0 + 96 * $100   ;
   FX_Soundtrack          : Ret := $C0 + 97 * $100   ;
   FX_Crystal             : Ret := $C0 + 98 * $100   ;
   FX_Atmosphere          : Ret := $C0 + 99 * $100   ;
   FX_Brightness          : Ret := $C0 + 100 * $100   ;
   FX_Goblins             : Ret := $C0 + 101 * $100   ;
   FX_Echoes              : Ret := $C0 + 102 * $100   ;
   FX_Star                : Ret := $C0 + 103 * $100   ;
   Sitar                  : Ret := $C0 + 104 * $100   ;
   Banjo                  : Ret := $C0 + 105 * $100   ;
   Shamisen               : Ret := $C0 + 106 * $100   ;
   Koto                   : Ret := $C0 + 107 * $100   ;
   Kalimba                : Ret := $C0 + 108 * $100   ;
   Bagpipe                : Ret := $C0 + 109 * $100   ;
   Fiddle                 : Ret := $C0 + 110 * $100   ;
   Shanai                 : Ret := $C0 + 111 * $100   ;
   Tinkle_Bell            : Ret := $C0 + 112 * $100   ;
   Agogo                  : Ret := $C0 + 113 * $100   ;
   Steel_Drums            : Ret := $C0 + 114 * $100   ;
   Woodblock              : Ret := $C0 + 115 * $100   ;
   Taiko_Drum             : Ret := $C0 + 116 * $100   ;
   Melodic_Tom            : Ret := $C0 + 117 * $100   ;
   Synth_Drum             : Ret := $C0 + 118 * $100   ;
   Reverse_Cymbal         : Ret := $C0 + 119 * $100   ;
   Guitar_Fret_Noise      : Ret := $C0 + 120 * $100   ;
   Breath_Noise           : Ret := $C0 + 121 * $100   ;
   Seashore               : Ret := $C0 + 122 * $100   ;
   Bird_Tweet             : Ret := $C0 + 123 * $100   ;
   Telephone              : Ret := $C0 + 124 * $100   ;
   Helicopter             : Ret := $C0 + 125 * $100   ;
   Applause               : Ret := $C0 + 126 * $100   ;
   Gunshot                : Ret := $C0 + 127 * $100   ;



end;
  //yύX
   midiOutShortMsg(hMidi, Ret);

end;





end.
