//==============================================================================
//
//                           uJ[lI{^v
//
//==============================================================================
//                                 Copyright 2001 Takeshi Okamoto(PAPY)
//                                 papy@hamal.freemail.ne.jp
//                                 http://homepage1.nifty.com/MADIA/ (Japanese)
//==============================================================================
//                                                                   Version 1.0
//==============================================================================
//
// Version 1.0     Ŋ@2001-01-19
//
//==============================================================================
unit SCB;

interface

uses
  Windows, Messages, SysUtils, Classes,  Controls, Forms,Graphics, Dialogs,ExtCtrls;

type
  TSelectColorButton = class(TCustomControl)
  private
    Timer    : TTimer;
    Pushed   : Boolean;
    FColor   : TColor;
    FOptions  : TColorDialogOptions;
    procedure SetColor(Value :TColor);
    procedure WMLBUTTONDOWN(Var Msg : TWMLBUTTONDOWN);message WM_LBUTTONDOWN;
    procedure WMLBUTTONDBLCLK(Var Msg : TWMLBUTTONDBLCLK);message WM_LBUTTONDBLCLK;
    procedure WMLBUTTONUP(Var Msg : TWMLBUTTONUP);message WM_LBUTTONUP;
    procedure OnTimerEvents(Sender: TObject) ;
  protected
     procedure Paint    ; override;
  public
     constructor Create(AOwner: TComponent); override;
     destructor  Destroy; override;
  published
    property Color : TColor  read FColor write SetColor ;
    property Options :  TColorDialogOptions read FOptions  write FOptions;
    property DragCursor;
    property DragMode;
    property Enabled;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop ;
    property Visible;
    property OnClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDrag;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('PAPY', [TSelectColorButton]);
end;

/////////////////////////////////////////////////////////////////////////////////

///////////
constructor TSelectColorButton.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Width   := 90;
  Height  := 25;
  FColor :=clyellow;
  Pushed  := False;
  Timer   := TTimer.Create(Self);
  Timer.Interval := 100;
  Timer.OnTimer  := OnTimerEvents;
  Timer.Enabled  := False;
end;

///////////
destructor  TSelectColorButton.Destroy;
begin
  Timer.Free;
  inherited Destroy;
end;

/////////
procedure TSelectColorButton.SetColor(Value :TColor);
begin
  if Value=FColor then  Exit;
  FColor :=Value;
  Paint;
end;

/////////
procedure TSelectColorButton.PAINT;
Var
 MyRect :TRect;
begin
 MyRect :=Rect(0,0,width,Height);
  if not Pushed then
  begin
    DrawEdge(Canvas.Handle, MyRECT, EDGE_RAISED, BF_RECT);
    Canvas.Brush.Color :=FColor;
    Canvas.Rectangle(5,5,Width-5,Height-5);
  end
  else
  begin
    DrawEdge(Canvas.Handle, MyRECT, EDGE_SUNKEN, BF_RECT);
    Canvas.Brush.Color :=FColor;
    Canvas.Rectangle(5,5,Width-5,Height-5);
  end;
end;

/////////
procedure TSelectColorButton.OnTimerEvents(Sender: TObject) ;
var
Poi      : TPoint;
begin
  GetCursorPos(Poi);
  Poi := Self.ScreenToClient(Poi);
  if (Poi.X <0 ) or (Poi.Y<0) or (Poi.X>Self.Width) or (Poi.Y>Self.Height)   then
  begin
    Pushed :=False;
    Paint;
    Timer.Enabled :=False;
 end;

end;

//bZ[W--------------------------------------------------------------------

/////////
procedure TSelectColorButton.WMLBUTTONDOWN(Var Msg : TWMLBUTTONDOWN);
begin
  if (csDesigning in ComponentState) then EXit;
  Timer.Enabled :=True;
  Pushed :=True;
  Paint;
end;

/////////
procedure TSelectColorButton.WMLBUTTONDBLCLK(Var Msg : TWMLBUTTONDBLCLK);
begin
  if (csDesigning in ComponentState) then EXit;
  Timer.Enabled :=True;
  Pushed :=True;
  Paint;
end;

/////////
procedure TSelectColorButton.WMLBUTTONUP(Var Msg : TWMLBUTTONUP);
Var
 ColorDialog :TColorDialog;
begin
 if (csDesigning in ComponentState) then EXit;
 Timer.Enabled :=False;

 if Pushed  then
 begin
   ColorDialog :=TColorDialog.Create(self);
   ColorDialog.Options := FOptions;
   if ColorDialog.Execute then
   begin
    FColor :=ColorDialog.Color;
   end;
   Pushed :=False;
   Paint;
   Click;
   ColorDialog.Free;
 end
 else
  Paint;

end;


end.
