//==============================================================================
//
//           uScreenCapturetTImagev
//
//==============================================================================
//                                 Copyright 2001 Takeshi Okamoto(PAPY)
//                                 papy@hamal.freemail.ne.jp
//                                 http://homepage1.nifty.com/MADIA/ (Japanese)
//==============================================================================
//                                                                   Version 1.0
//==============================================================================
//
// Version 1.00     J@2001-01-16
//
//==============================================================================
unit SCImage;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls;

type
  TScreenCaptureImage = class(TImage)
  private
    { Private 錾 }
     FActiveWindow :Boolean;
     FMouseCursor  :Boolean;
     FMenuBar      :Boolean;
  protected
    { Protected 錾 }
  public
    { Public 錾 }
    constructor    Create(AOwner: TComponent); override;
    destructor     Destroy; override;
    procedure      ScreenCapture;
  published
    { Published 錾 }
    property SC_ActiveWindow :Boolean read FActiveWindow  write FActiveWindow;
    property SC_MouseCursor  :Boolean read FMouseCursor   write FMouseCursor;
    property SC_MenuBar      :Boolean read FMenuBar       write FMenuBar;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('PAPY', [TScreenCaptureImage]);
end;

////////////////////////////////////////////////////////////////////////////////

//----------------------------------------------------------------------
//֐  Capture
//pr@  ʂLv`
//
//          ActiveWindow...  True  ANeBuEChELv`
//                           False XN[ŜLv`
//          MouseCursor ...  True  }EXJ[\܂߂
//                           False }EXJ[\܂߂Ȃ
//          MenuBar     ...  True  j[o[܂߂
//                           False j[o[܂߂Ȃ
//߂l  rbg}bṽnh
//----------------------------------------------------------------------
function Capture(Const ActiveWindow,MouseCursor,MenuBar : Boolean ) :integer ;
var
  hWnd      : Integer;  // Lv`EBhEnh
  DC        : Integer;  // Lv`EBhEfoCXReLXg
  Rect      : Trect  ;
  T, L, W, H: Integer;  // rbg}bvWn
  CurPos    : TPoint ;  // }EXJ[\W
  BMP       : TBItMAP;
  WinBottom : integer;
  WinLeft   : integer;
begin
  WinBottom :=0;
  WinLeft   :=0;

  if ActiveWindow then
     hWnd := GetForegroundWindow
  else
     hWnd := GetDesktopWindow;

  if hWnd=0  then   begin  Result :=0;  Exit;  end;

      GetWindowRect(hWnd, RECT);

      //fXNgbv͂ݏo͈͂폜
      if RECT.Left   > 0 then L := 0
      else L :=  -(RECT.Left);
      if RECT.Top    > 0 then T := 0
      else T :=  -(RECT.Top);
      if RECT.Right  < GetSystemMetrics(SM_CXSCREEN)  then W := Rect.Right - Rect.Left - L
      else W :=GetSystemMetrics(SM_CXSCREEN)  - Rect.Left - L;
      if RECT.Bottom < GetSystemMetrics(SM_CYSCREEN) then H := Rect.Bottom  - Rect.Top  - T
      else H := GetSystemMetrics(SM_CYSCREEN) - Rect.Top  - T;

   Bmp := TBitmap.Create;


  //j[o[܂߂̂H
  if MenuBar then
  begin
     DC := GetWindowDC(hWnd);
     Bmp.Width   :=W;
     Bmp.Height  :=H;
  end
  else
  begin
     DC := GetDC(hWnd);
     WinBottom :=Rect.Bottom;
     WinLeft   :=Rect.Left;
     GetClientRect(hWnd,Rect);
     Bmp.Width   :=W-4;
     if WinBottom >GetSystemMetrics(SM_CYSCREEN) then
     begin
       BMP.Height :=GetSystemMetrics(SM_CYSCREEN)-(WinBottom-Rect.Bottom);
     end
     else
      Bmp.Height  :=Rect.Bottom;

     T :=0;
  end;

  //Lv`
  BitBlt(Bmp.Canvas.Handle, 0, 0, Bmp.Width, Bmp.Height, DC, L,T, SRCCOPY);
  ReleaseDC(hWnd,DC);

  // }EXJ[\
  if MouseCursor then
  begin
    GetCursorPos(CurPos);

    if MenuBar then
      DrawIcon(Bmp.Canvas.Handle, CurPos.X - RECT.Left, CurPos.Y - RECT.Top, GetCursor)
    else
    begin
      if WinBottom>GetSystemMetrics(SM_CYSCREEN) then
      begin
        if WinLeft >0 then
          DrawIcon(Bmp.Canvas.Handle, CurPos.X-  WinLeft  , (Rect.Bottom+CurPos.Y)-WinBottom, GetCursor)
        else
          DrawIcon(Bmp.Canvas.Handle, CurPos.X   , (Rect.Bottom+CurPos.Y)-WinBottom, GetCursor);
      end
      else
      begin
          GetWindowRect(hWnd,RECT);
          if WinLeft >0 then
            DrawIcon(Bmp.Canvas.Handle, CurPos.X-Rect.left , CurPos.Y+(Bmp.height-Rect.Bottom), GetCursor)
          else
            DrawIcon(Bmp.Canvas.Handle, CurPos.X , CurPos.Y+(Bmp.height-Rect.Bottom), GetCursor);
     end;
   end;
  end;

  Result := Bmp.ReleaseHandle;
  Bmp.Free;

end;



////////////////////////////////////////////////////////////////////////////////

///////////
constructor TScreenCaptureImage.Create(AOwner: TComponent);
begin
   inherited Create(AOwner);
end;


//////////
destructor TScreenCaptureImage.Destroy;
begin
  inherited Destroy;
end;

/////////
procedure TScreenCaptureImage.ScreenCapture ;
Var
 hBMP : integer;
begin
 hBMP := Capture(FActiveWindow,FMouseCursor,FMenuBar);
 if hBMP<>0 then
 begin
  Self.Picture :=nil;
  Self.Picture.Bitmap.Handle :=hBMP;
 end; 
end;



end.
