//==============================================================================
//
//           uʃ{[v
//
//==============================================================================
//                                 Copyright 2000-2001 Takeshi Okamoto(PAPY)
//                                 papy@hamal.freemail.ne.jp
//                                 http://homepage1.nifty.com/MADIA/ (Japanese)
//==============================================================================
//                                                                   Version 1.2
//==============================================================================
//
// Version 1.00     J@2000-09
//         1.1            @2000-09 -30
//         1.2              2001-01 -16
//                          ...݌vɐݒ肵esɔf̂
//                             ߂Ď葱ŉʁE~[g̏ԂύX悤ɂ
//
//==============================================================================

unit VolumeControl;

interface

uses
  Windows, Messages, SysUtils, Classes,MMsystem,Graphics, Controls, Forms;

type
  TMIXERCONTROLDETAILS_UNSIGNED=record
     dwValue : integer;
end;

type
  TMIXERCONTROLDETAILS_BOOLEAN=record
     fValue : integer;
end;

type

  TMixerChange=procedure (Sender:TObject) of object;

  TVolumeControl = class(TComponent)

  private
    { Private 錾 }

      FVolume           : Word        ;
      FMute             : Boolean     ;
      FOnCONTROLChange  : TMixerChange;

      MixerHandle   : HMixer             ;//~LT[ރ
      dwHandle      : HWnd               ;
      ML            : TMixerLine         ;//MixerLine\
      MLT           : TMIXERLINECONTROLS ;//MIXERLINECONTROLS\
      MXC           : TMIXERCONTROL      ;//MIXERCONTROL\

     procedure MixerControlInfo(ControlType : integer);
     Procedure SetMuteEx (Flag : Boolean );
     Procedure GetMute ;
     function  GetMuteEx:Boolean ;
     Procedure SetVolumeEx(Value: Word);
     Procedure GetVolume;
     function  GetVolumeEx:WOrd;
     procedure MixerCallBack (var Msg:TMessage);

  protected
    { Protected 錾 }

  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; override;

  published
    { Published 錾 }
      property  Volume : Word    read GetVolumeEx ;
      property  Mute   : Boolean read GetMuteEx   ;
      property  OnControlChange:TMixerChange  read FOnCONTROLChange write FOnCONTROLChange;
      procedure SetVolume(Value :Word);
      procedure SetMute(Value : Boolean);
  end;

procedure Register;

implementation
{$R VOLUMECONTROL.RES}

///////////
constructor TVolumeControl.Create(AOwner: TComponent);
var
 hMem     : integer;   //IuWFNg̃nh
begin
   inherited Create(AOwner);

   dwHandle :=AllocateHWnd(MixerCallBack);

   //~LT[foCXJ
   mixerOpen(@MixerHandle,0,dwHandle,0, CALLBACK_WINDOW OR MIXER_OBJECTF_MIXER);

   //MixerLine\̂̐ݒ
   ML.cbStruct        := Sizeof(TMixerLine);
   ML.dwComponentType := MIXERLINE_COMPONENTTYPE_DST_SPEAKERS ;

   //~LT[C̏擾
   mixerGetLineInfo(MixerHandle,@ML, MIXER_GETLINEINFOF_COMPONENTTYPE);

   //MIXERLINECONTROLS\̂̐ݒ
   MLT.cbStruct := Sizeof(TMIXERLINECONTROLS) ;
   MLT.dwLineID := ML.dwLineID  ;
   MLT.dwControlType := MIXERCONTROL_CONTROLTYPE_VOLUME ;
   MLT.cControls := 1   ;
   MLT.cbmxctrl := sizeof(TMixerLine) ;

   //ubN̊m (ZERONA)
   hMem         := GlobalAlloc(GMEM_ZEROINIT, Sizeof(TMixerLine)) ;
   MLT.pamxctrl := GlobalLock(hMem)  ;  // ubÑbN
   MXC.cbStruct := sizeof(TMIXERCONTROL)   ;

   //C̃Rg[擾
   mixerGetLineControls(MixerHandle, @MLT, MIXER_GETLINECONTROLSF_ONEBYTYPE) ;

   CopyMemory(@MXC,MLT.pamxctrl, Sizeof(TMIXERCONTROL));

   // J
   GlobalFree (hMem)  ;

   //ݒǂݍ
   GetVolume ;
   GetMute ;

end;

//////////
destructor TVolumeControl.Destroy;
begin
  mixerClose(MixerHandle);
  if  dwHandle <>0 then  DeAllocateHwnd(dwHandle);
  inherited Destroy;
end;

{--------------------}
{{[擾}
{--------------------}
Procedure  TVolumeControl.GetVolume;
var
 MXCD   : TMIXERCONTROLDETAILS         ;//MIXERCONTROLDETAILS\
 MXCDU  : TMIXERCONTROLDETAILS_UNSIGNED;//MIXERCONTROLDETAILS_UNSIGNED\
 hMem   : integer                      ;// IuWFNg̃nh
begin

    //Rg[擾
    MixerControlInfo(MIXERCONTROL_CONTROLTYPE_VOLUME);

    //MIXERCONTROLDETAILS\̂̐ݒ
    MXCD.cMultipleItems  :=0     ;
    MXCD.dwControlID     :=MXC.dwControlID  ;
    MXCD.cbStruct        :=Sizeof(TMIXERCONTROLDETAILS) ;
    MXCD.cbDetails       :=Sizeof(TMIXERCONTROLDETAILS_UNSIGNED);

    // ubN̊m (ZERONA)
    hMem             :=GlobalAlloc(GMEM_ZEROINIT, sizeof(TMIXERCONTROLDETAILS_UNSIGNED));
    MXCD.paDetails   :=GlobalLock(hMem) ;    // ubÑbN
    MXCD.cChannels   := 1 ;
    MXCDU.dwValue    := 0 ;

    //{[Rg[̐ݒl擾
    mixerGetControlDetails
     (MixerHandle, @MXCD, MIXER_GETCONTROLDETAILSF_VALUE);

    //AhX\̂ɒlRs[
    CopyMemory(@MXCDU,pointer(MXCD.paDetails), Sizeof(TMIXERCONTROLDETAILS_UNSIGNED));

    //
    GlobalFree(hMem);

    FVolume :=MXCDU.dwValue;

end;


{--------------------}
{{[ݒ肷}
{--------------------}
Procedure TVolumeControl.SetVolumeEx(Value : Word);
Var
MXCD   : TMIXERCONTROLDETAILS         ;//MIXERCONTROLDETAILS\
MXCDU  : TMIXERCONTROLDETAILS_UNSIGNED;//MIXERCONTROLDETAILS_UNSIGNED\
hMem   : integer                      ;// IuWFNg̃nh
begin

    FVolume :=Value;

    //Rg[擾
    MixerControlInfo( MIXERCONTROL_CONTROLTYPE_VOLUME);

    //MIXERCONTROLDETAILS\̂̐ݒ
    MXCD.cMultipleItems := 0  ;
    MXCD.dwControlID    := MXC.dwControlID  ;
    MXCD.cbStruct       := Sizeof(TMIXERCONTROLDETAILS)  ;
    MXCD.cbDetails      := Sizeof(TMIXERCONTROLDETAILS_UNSIGNED) ;

    //ubN̊m (ZERONA)
    hMem            := GlobalAlloc(GMEM_ZEROINIT, Sizeof(TMIXERCONTROLDETAILS_UNSIGNED)) ;
    MXCD.paDetails  := GlobalLock(hMem);  // ubÑbN
    MXCD.cChannels  := 1  ;
    MXCDU.dwValue   := Value;

    //\̂̒lRs[
    CopyMemory(pointer(MXCD.paDetails), @MXCDU, Sizeof(TMIXERCONTROLDETAILS_UNSIGNED));

    //Rg[̒lZbg
    mixerSetControlDetails(MixerHandle, @MXCD, MIXER_SETCONTROLDETAILSF_VALUE) ;

    //
    GlobalFree(hMem);

end;

{------------------}
{~[gԂ̐ݒ}
{------------------}
Procedure TVolumeControl.SetMuteEx (Flag : Boolean );
Var
 MXCD   : TMIXERCONTROLDETAILS         ;//MIXERCONTROLDETAILS\
 MXCDB  : TMIXERCONTROLDETAILS_BOOLEAN ;//MIXERCONTROLDETAILS_BOOLEAN\
 hMem   : integer;
 ptr    : pointer;
 dwFlag : Integer;
begin

    if Flag then
        dwFlag :=1
    else
        dwFlag :=0;

    FMute :=Flag;

    //Rg[擾
    MixerControlInfo(MIXERCONTROL_CONTROLTYPE_MUTE);

    //q[vMIXERCONTROLDETAILS_BOOLEAN\̂̃TCỸubNmۂ
    hMem :=GlobalAlloc(GHND, Sizeof(TMIXERCONTROLDETAILS_BOOLEAN)) ;

    //ubNbNă|C^擾
    ptr  := GlobalLock(hMem);

    //TMIXERCONTROLDETAILS\̂̐ݒ
    MXCD.cbStruct      := Sizeof(TMIXERCONTROLDETAILS);
    MXCD.dwControlID   := MXC.dwControlID ;
    MXCD.cChannels     := 1 ;
    MXCD.cMultipleItems:= 0 ;
    MXCD.cbDetails     := Sizeof(TMIXERCONTROLDETAILS_BOOLEAN)  ;
    MXCD.paDetails     := ptr ;

    //paDetails̃|C^Ƀ~[g̒lZbg
    MXCDB.fValue :=dwFlag; {ЭĂ0, off 1, on}

    //ɃRs[
    CopyMemory(ptr, @MXCDB, Sizeof(TMIXERCONTROLDETAILS_BOOLEAN)) ;

    //~[gRg[ɃtOݒ肷
    mixerSetControlDetails(MixerHandle, @MXCD, MIXER_SETCONTROLDETAILSF_VALUE);

    //ubNbN
    GlobalUnlock(hMem);

    //ubN
    GlobalFree(hMem);

end;



{------------------}
{~[gԂ̎擾}
{------------------}
Procedure TVolumeControl.GetMute;
var
 hMem   : integer;                      //IuWFNg̃nh
 ptr    : pointer;                      //|C^[
 MXCD   : TMIXERCONTROLDETAILS         ;//MIXERCONTROLDETAILS\
 MXCDB  : TMIXERCONTROLDETAILS_BOOLEAN ;//MIXERCONTROLDETAILS_BOOLEAN\
begin

     //Rg[擾
     MixerControlInfo(MIXERCONTROL_CONTROLTYPE_MUTE);

     //q[vMIXERCONTROLDETAILS_BOOLEAN\̂̃TCỸubNmۂ
     hMem :=GlobalAlloc(GHND, Sizeof(TMIXERCONTROLDETAILS_BOOLEAN)) ;

     //ubNbNă|C^擾
     ptr  := GlobalLock(hMem);

     //TMIXERCONTROLDETAILS\̂̐ݒ
     MXCD.cbStruct      := Sizeof(TMIXERCONTROLDETAILS);
     MXCD.dwControlID   := MXC.dwControlID ;
     MXCD.cChannels     := 1 ;
     MXCD.cMultipleItems:= 0 ;
     MXCD.cbDetails     := Sizeof(TMIXERCONTROLDETAILS_BOOLEAN)  ;
     MXCD.paDetails     := ptr ;

     //~[gRg[tO擾
     mixerGetControlDetails(MixerHandle, @MXCD, MIXER_SETCONTROLDETAILSF_VALUE);

     //ɃRs[
     CopyMemory(@MXCDB,ptr,Sizeof(TMIXERCONTROLDETAILS_BOOLEAN)) ;

     //ubNbN
     GlobalUnlock(hMem);

     //ubN
     GlobalFree(hMem);

     if   MXCDB.fValue =1 then
         FMute :=True
     else
         FMute :=False;
end;


{--------------------------}
{Rg[擾}
{--------------------------}
procedure TVolumeControl.MixerControlInfo(ControlType : integer);
Var
hMem   : integer;
ptr    : pointer;
begin
    //q[vMIXERCONTROL\̂̃TCỸubNmۂ
    hMem := GlobalAlloc(GHND, Sizeof(TMIXERCONTROL));

    //ubNbNă|C^擾
    ptr  := GlobalLock(hMem);

    //MIXERLINECONTROLS\̂̐ݒ
     MLT.cbStruct      := Sizeof(TMIXERLINECONTROLS)      ;
     MLT.dwLineID      := ML.dwLineID                     ;
     MLT.dwControlType := ControlType                     ;
     MLT.cControls     := 1                               ;
     MLT.cbmxctrl      := Sizeof(TMIXERCONTROL)           ;
     MLT.pamxctrl      := ptr                             ;

    //C̃Rg[擾
    mixerGetLineControls(MixerHandle, @MLT, MIXER_GETLINECONTROLSF_ONEBYTYPE);

    //|C^MIXERCONTROL\̂̒lo
    CopyMemory(@MXC,ptr, Sizeof(TMIXERCONTROL)) ;

    //ubNbN
    GlobalUnlock(hMem);

    //ubN
    GlobalFree(hMem);

end;

/////////
function TVolumeControl.GetVolumeEx;
begin
   GetVolume;
   Result:=FVolume;
end;

/////////
function TVolumeControl.GetMuteEx;
begin
   GetMute;
   Result:=FMute;
end;

/////////
procedure TVolumeControl.SetVolume(Value :Word);
begin
  SetVolumeEx(Value);
end;

/////////
procedure TVolumeControl.SetMute(Value : Boolean);
begin
 SetMuteEx(Value);
end;

{------------------}
{bZ[W̃tbN}
{------------------}

procedure TVolumeControl.MixerCallBack (var Msg:TMessage);
begin
 if Msg.Msg=MM_MIXM_CONTROL_CHANGE then
 begin
       If Assigned (OnCONTROLChange) then
          OnCONTROLChange (Self);
 end;
end;

procedure Register;
begin
  RegisterComponents('PAPY', [TVolumeControl]);
end;

end.
